# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2007-2014 ASPerience SARL (<http://www.asperience.fr>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import fields,osv
#import openerp.netsvc
#from openerp.tools.translate import _
#from openerp.tools import ustr
import logging
_logger = logging.getLogger(__name__)

class mrp_bom_component_mode(osv.osv):
    _name = 'mrp.bom.component.mode'
    _description = 'mrp.bom.component.mode'
    _columns = {
        'name': fields.char('Description', size=256, required=True),
        'dx': fields.text('Dx'),
        'dy': fields.text('Dy'),
        'dz': fields.text('Dz'),
        'dd': fields.text('Dd'),
    }
    _defaults = {
    }
    
mrp_bom_component_mode()

class mrp_bom_component_rel(osv.osv):
    _name = 'mrp.bom.component.rel'
    _description = 'mrp.bom.component.rel'
    _columns = {
        'bom_id': fields.many2one('mrp.bom', 'Bom', required=True, ondelete='cascade'),
        'component_id': fields.many2one('mrp.bom', 'Component', required=True, ondelete='cascade'),
#        'product_component_id': fields.related('component_id','product_id',type='many2one', relation="product.product", string="Product"),
        'qty': fields.float('Quantity', required=True),
        'mode': fields.many2one('mrp.bom.component.mode', 'Mode'),
    }

    def compute_size(self, cr, uid, ids, context={}):
        logger = netsvc.Logger()
        if not ids :
            return False
        result = {}
        for i in self.browse(cr,uid,ids,context):
            space = {}
            space["x"] = context.get("size_x",0.0)
            space["y"] = context.get("size_y",0.0)
            space["z"] = context.get("size_z",0.0)
            space["d"] = context.get("diameter",0.0)
            space["Dx"] = context.get("size_x_specific_delta",0.0)
            space["Dy"] = context.get("size_y_specific_delta",0.0)
            space["Dz"] = context.get("size_z_specific_delta",0.0)
            space["Dd"] = context.get("diameter_specific_delta",0.0)
            
            
            result[i.id] = {
                            "size_x_specific_delta":0.0,
                            "size_y_specific_delta":0.0,
                            "size_z_specific_delta":0.0,
                            "diameter_specific_delta":0.0,
                            "size_x_specific":context.get("size_x",0.0),
                            "size_y_specific":context.get("size_y",0.0),
                            "size_z_specific":context.get("size_z",0.0),
                            "diameter_specific":context.get("diameter",0.0),
            }
            
            try:
                result[i.id]["size_x_specific_delta"] = eval(i.mode.dx,space)
                result[i.id]["size_x_specific"] = result[i.id]["size_x_specific"] - result[i.id]["size_x_specific_delta"]
            except Exception, e:
                logger.notifyChannel('eval size', netsvc.LOG_WARNING, e)
                logger.notifyChannel('eval size', netsvc.LOG_WARNING, "transform x "+str(i.mode.dx))
            try:
                result[i.id]["size_y_specific_delta"] = eval(i.mode.dy,space)
                result[i.id]["size_y_specific"] = result[i.id]["size_y_specific"] - result[i.id]["size_y_specific_delta"]
            except Exception, e:
                logger.notifyChannel('eval size', netsvc.LOG_WARNING, e)
                logger.notifyChannel('eval size', netsvc.LOG_WARNING, "transform y "+str(i.mode.dy))
            try:
                result[i.id]["size_z_specific_delta"] = eval(i.mode.dz,space)
                result[i.id]["size_z_specific"] = result[i.id]["size_z_specific"] - result[i.id]["size_z_specific_delta"]
            except Exception, e:
                logger.notifyChannel('eval size', netsvc.LOG_WARNING, e)
                logger.notifyChannel('eval size', netsvc.LOG_WARNING, "transform z "+str(i.mode.dz))
            try:
                result[i.id]["diameter_specific_delta"] = eval(i.mode.dd,space)
                result[i.id]["diameter_specific"] = result[i.id]["diameter_specific"] - result[i.id]["diameter_specific_delta"]
            except Exception, e:
                logger.notifyChannel('eval size', netsvc.LOG_WARNING, e) 
                logger.notifyChannel('eval size', netsvc.LOG_WARNING, "transform d "+str(i.mode.dd))
            
        return result
    
    _defaults = {
    }
mrp_bom_component_rel()

def rounding(f, r):
    if not r:
        return f
    return round(f / r) * r

class mrp_bom(osv.osv):
    _inherit = 'mrp.bom'
    
#    def __init__(self, pool, cr):
#        super(mrp_bom,self).__init__(pool,cr)
#        cr.execute('select count(*) from mrp_bom_childs_rel')
#        nb1 = cr.dictfetchall()[0]['count']
#        cr.execute('select count(*) from mrp_bom_component_rel')
#        nb2 = cr.dictfetchall()[0]['count']
#        if nb1 and not nb2 :
#            cr.execute('insert into mrp_bom_component_rel\
#                        (bom_id,component_id,qty)\
#                        select a.bom_id, a.child_id, b.product_qty\
#                        from mrp_bom_childs_rel a join mrp_bom b on a.bom_id = b.id')
#            
#            map_mode = {
#                        'bottom':['.DES.'],
#                        'top':['PLATEAU'],
#                        'back':['.DER.'],
#                        'front':['.FACE.'],
#                        'side':['.COT.'],
#                        }
#            for i in map_mode:
#                for j in map_mode[i]:
#                    cr.execute("update mrp_bom_component_rel\
#                                set mode = (    select id\
#                                        from mrp_bom_component_mode\
#                                        where name = '"+ustr(i)+"')\
#                                where id in (\
#                                    select a.id\
#                                    from mrp_bom_component_rel a join mrp_bom b on a.component_id = b.id join product_product c on b.product_id = c.id join product_template d on c.product_tmpl_id = d.id\
#                                    where c.default_code like '%"+ustr(j)+"%');")
            
            
    def _child_compute(self, cr, uid, ids, name, arg, context={}):
        result = {}
        for bom in self.browse(cr, uid, ids, context=context):
            result[bom.id] = map(lambda x: x.component_id.id, bom.bom_components)
            if bom.bom_components:
                continue
            ok = ((name=='child_complete_ids') and (bom.product_id.supply_method=='produce'))
            if bom.type=='phantom' or ok:
                sids = self.pool.get('mrp.bom').search(cr, uid, [('bom_id','=',False),('product_id','=',bom.product_id.id)])
                if sids:
                    bom2 = self.pool.get('mrp.bom').browse(cr, uid, sids[0], context=context)
                    result[bom.id] += map(lambda x: x.component_id.id, bom2.bom_components)
        return result

    def _compute_type(self, cr, uid, ids, field_name, arg, context):
        res = dict(map(lambda x: (x,''), ids))
        for line in self.browse(cr, uid, ids):
            if line.type=='phantom' and not line.bom_id:
                res[line.id] = 'set'
                continue
            if line.bom_lines or line.bom_components or line.type=='phantom':
                continue
            if line.product_id.supply_method=='produce':
                if line.product_id.procure_method=='make_to_stock':
                    res[line.id] = 'stock'
                else:
                    res[line.id] = 'order'
        return res

    _columns = {
        #Dimensions
        'size_x': fields.float('Width', digits=(16, 5)),
        'size_y': fields.float('Length', digits=(16, 5)),
        'size_z': fields.float('Thickness', digits=(16, 5)),
        'density': fields.float('Density', digits=(16, 5)),
        'shape' : fields.selection([('quadrangular', 'Quadrangular'), ('cylindrical', 'Cylindrical'), ('other', 'Other')], 'Shape', required=True),
        'diameter' : fields.float('Diameter', digits=(16, 5)),
        'weight': fields.float('Weight', digits=(16, 5)),
        #Production
        'bom_type': fields.selection([('ass','Assemble'),('exp','Disassemble'),('cut','Cutting'),('cutinput','Cutting Input'),('picking','Picking'),('delay','Delay'),('control','Quality control')], 'BOM Type', required=True ),
        'bom_lines_multi': fields.many2many('mrp.bom', 'mrp_bom_childs_rel', 'bom_id', 'child_id', 'Child BoMs'),
        'bom_parent_multi': fields.many2many('mrp.bom', 'mrp_bom_childs_rel', 'child_id', 'bom_id', 'Parent BoMs'),
        'bom_components': fields.one2many('mrp.bom.component.rel', 'bom_id', 'Components'),
        'bom_components_parent': fields.one2many('mrp.bom.component.rel', 'component_id', 'Parent Components'),
        'method': fields.function(_compute_type, string='Method', method=True, type='selection', selection=[('',''),('stock','On Stock'),('order','On Order'),('set','Set / Pack')]),
        'type_group_ids': fields.many2many('product.type.property.option', 'mrp_bom_options_rel', 'bom_id', 'type_id', 'GOO',help="Used to map which property option is taken from previous product in assembly chain, or pushed to in dissambly chain"),
        'child_complete_ids': fields.function(_child_compute,relation='mrp.bom', method=True, string="BoM Hyerarchy", type='many2many'),
#        'group_property_ids': fields.many2many('mrp.property.group.option', 'mrp_bom_group_property_rel','bom_id', 'group_id', 'BOM Property Group Rel', help="Used to produce with properties not defined in sale order"),
        'sub_product_ids': fields.many2many('mrp.subproduct', 'mrp_bom_subproduct_rel','bom_id', 'sub_id', 'Sub products'),
    }
    _defaults = {
            'bom_type': lambda *a: 'ass'
    }

    def compute_weight(self, cr, uid, id, product_id, size_x, size_y, size_z, shape, density, diameter):
       if product_id:
           product = self.pool.get('product.product').browse(cr, uid, product_id, context='')
           factor1 = product.uom_d_weight.factor
           factor2 = product.uom_id.factor
           factor3 = product.uom_d_size.factor  
           factor4 = product.uom_s_size.factor           
           return {'value': compute_w(cr, uid, factor1, factor2, factor3, factor4, size_x, size_y, size_z, shape, density, diameter)}
   
    def onchange_product_id(self, cr, uid, ids, product_id, name, id, context={}):
        if product_id:
            w = self.pool.get('product.product').browse(cr, uid, [product_id], context)[0]
            factor1 = w.uom_d_weight.factor
            factor2 = w.uom_id.factor
            factor3 = w.uom_d_size.factor
            factor4 = w.uom_s_size.factor            
            v = {
                'product_uom':w.uom_id.id,
                'product_uos':w.uos_id and w.uos_id.id or w.uom_id.id,
                'size_x':w.size_x or w.size_x_tmpl,
                'size_y':w.size_y or w.size_y_tmpl,
                'size_z':w.size_z or w.size_z_tmpl,
                'density':w.density or w.density_tmpl,
                'shape':w.shape,
                'diameter':w.diameter or w.diameter_tmpl,
                'weight': compute_w(cr, uid, factor1, factor2, factor3, factor4, w.size_x or w.size_x_tmpl, w.size_y or w.size_y_tmpl, w.size_z or w.size_z_tmpl, w.shape, w.density or w.density_tmpl, w.diameter or w.diameter_tmpl)['weight'],
                'name' : w.name,
            }
            if id :
                v['bom_id'] = id
            return {'value': v}
        return {}

    def button_quality_control(self,cr,uid,ids,context={}):
        revision_obj = self.pool.get('stock.production.lot.revision')
        attachment_obj = self.pool.get('ir.attachment')
        for i in ids:
            lot = self.browse(cr,uid,i)
            if not lot.production_date:
                raise osv.except_osv(_('Error :"'),_("Missing production date"))

            if lot.revisions:
                indice = (max([eval(revision.indice) for revision in lot.revisions]) or 0) + 1
            else:
                indice = 1
            vals = {
                'name': _("certificate"),
                'description': _("Conformity certificate generation"),
                'indice': str(indice),
                'date': datetime.datetime.now(),
                'author_id': uid,
                'lot_id': i,
            }
            revision_obj.create(cr,uid,vals)
            report = "stock.production.lot.conformity.certificate"
            ir_obj = self.pool.get('ir.actions.report.xml')
            report_xml_ids = ir_obj.search(cr, uid,[('report_name', '=', report)])
            if report_xml_ids:
                report_xml = ir_obj.browse(cr, uid, report_xml_ids[0])
                service = netsvc.LocalService("report."+report)
                (r, format) = service.create(cr, uid, [i], {}, {})
                report_file = report_xml.name+'.'+format
                report_datas = base64.encodestring(r)
                data_attach = {
                    'name': _('Conformity_certificate_')+(lot.name or '')+"_V"+str(indice),
                    'datas':report_datas,
                    'datas_fname': _('Conformity_certificate_')+(lot.name or '')+"_V"+str(indice)+".pdf",
                    'description': _('Conformity_certificate_')+(lot.name or '')+"_V"+str(indice)+".pdf",
                    'res_model': 'stock.production.lot',
                    'res_id': i
                }
                attachment_obj.create(cr,uid, data_attach)
        self.write(cr,uid,ids,{'quality_control':True})

        return True

    def _bom_find(self, cr, uid, product_id, product_uom, properties=[], group_properties_filter=[], bom_type='ass', level=0):
        level_str = "-"*level
        print_tab(level,"*"*50)
        print_tab(level,"_bom_find",product_id)
        print_tab(level,"_bom_find properties",properties)
        print_tab(level,"_bom_find group_properties_filter",group_properties_filter)
        pre = level_str+"_bom_find "
        print_tab(level,"_"*50)
        bom_result = False
        # Why searching on BoM without parent ?
        cr.execute('select id from mrp_bom where product_id=%s and bom_id is null and bom_type = %s order by sequence', (product_id,bom_type))
        ids = map(lambda x: x[0], cr.fetchall())
        
        if not ids :
            print_tab(pre+"generate all")
            self.pool.get('product.product').generate_bom(cr,uid,[product_id])
            print_tab(pre+"return bom_find after generate")
            print_tab("9"*50)
            return self._bom_find(cr, uid, product_id, product_uom, properties, group_properties_filter,level=level+1)
        
        max_prop = 0
        result = False
        
        if not properties and not group_properties_filter:
            #Produit configurable: recherche du BOM principal
            print_tab(pre+"Produit configurable: recherche du BOM principal",product_id)
            for bom in self.pool.get('mrp.bom').browse(cr, uid, ids):
                not_filter = True
                for group_id in bom.type_group_ids:
#                    print pre+"group_id ",group_id.id
                    if group_id.execution_filter :
#                        print pre+"group_id filter "
                        not_filter = False
                if not_filter:
                    result = bom.id
                    break
            if not result :
                self.pool.get('product.product').generate_bom(cr,uid,[product_id])
                return self._bom_find(cr, uid, product_id, product_uom, [], [],level=level+1)
        elif group_properties_filter :
            #Produit configurable: recherche du BOM lié au groupe de propriété
            print_tab(pre+"Produit configurable: recherche du BOM lié au groupe de propriété",product_id)
#            group_properties_filter = [i.type_group_id.id for i in self.pool.get('mrp.property.group.option').browse(cr, uid, group_properties_filter)]
            for bom in self.pool.get('mrp.bom').browse(cr, uid, ids):
                for group_id in bom.type_group_ids:
                    print_tab(pre+"group_id ",group_id.id,group_id.name,group_id.execution_filter)
                    print_tab(group_properties_filter)
                    if group_id.execution_filter and group_id.id in group_properties_filter:
                        result = bom.id
                        break
            if not result :
                parent = self._bom_find(cr, uid, product_id, product_uom,level=level+1)
                self.pool.get('product.product').generate_bom(cr,uid,[product_id],{"rec":1,"product_qty":1,"options":group_properties_filter, 'bom_parent':parent})[product_id]
                print_tab(pre+"return bom_find")
#                # CA NE FONCTIONNE PAS AVEC CA MAIS CE N4EST PAS NORMAL
                print_tab("8"*50)
                return self._bom_find(cr, uid, product_id, product_uom, properties, group_properties_filter,level=level+1)
        else:
            #Produit avec configuration mrp originale
            print pre+"Produit avec configuration mrp originale"
            for bom in self.pool.get('mrp.bom').browse(cr, uid, ids):
                prop = 0
                for prop_id in bom.property_ids:
                    if prop_id.id in properties:
                        prop+=1
                if (prop>max_prop) or ((max_prop==0) and not result):
                    result = bom.id
                    max_prop = prop

        print_tab(pre+"return result",result)
        print_tab("-"*50)
        return result
    
    def _bom_explode(self, cr, uid, bom, factor, properties, addthis=False, level=1, group_properties=[], procurement_id=False, context={}):
        level_str = "-"*level
        print_tab(level,"_bom_explode")
        print_tab(level,"procurement_id",procurement_id)
        print_tab(level,"bom.id",bom.id)
        factor = factor / (bom.product_efficiency or 1.0)
        factor = rounding(factor, bom.product_rounding)
        if factor<bom.product_rounding:
            factor = bom.product_rounding
        result = []
        result2 = []
        phantom=False
        if "bom_tree" not in context:
            context["bom_tree"] = []
        proc_obj = self.pool.get('procurement.order')
        bom_obj = self.pool.get('mrp.bom')      
        proc_ptr = False     
        if procurement_id:
            proc_ptr = proc_obj.browse(cr,uid,procurement_id)
        #=======================================================================
        # Filtres
        #=======================================================================
        filter = []
        no_filter = []
        property_group = []
        for i in bom.type_group_ids :
            if i.execution_filter :
                filter.append(i.id)
            else:
                no_filter.append(i.id)
        
        #=======================================================================
        # Phantom
        #=======================================================================
        if bom.type=='phantom' :#and not bom.bom_lines and not bom.bom_components:
#            print_tab(level,"phantom : product search :",bom.product_id.default_code,bom.product_id.name)
#            newbom = self._bom_find(cr, uid, bom.product_id.id, bom.product_uom.id, properties)
#            print_tab(level,"phantom : product ok:",self.browse(cr, uid, [newbom])[0].product_id.default_code,self.browse(cr, uid, [newbom])[0].product_id.name)
#            if newbom:
#                if bom.id not in context["bom_tree"]:
#                    context["bom_tree"].append(bom.id)
#                
#                res = self._bom_explode(cr, uid, self.browse(cr, uid, [newbom])[0], factor*bom.product_qty, properties, addthis=True, level=level+10, group_properties=group_properties, procurement_id=procurement_id, context=context)
#                result = result + res[0]
#                result2 = result2 + res[1]
#                phantom=True
#            else:
                phantom=False
        #=======================================================================
        # Not phantom
        #=======================================================================
        if not phantom:
            print_tab(level,"not phantom : product :",bom.product_id.name)
            #===================================================================
            # Bom without filter
            #===================================================================
            if not filter :
                print_tab(level,"nomenclature sans filtre",context)
                print_tab(level,"addthis and ((not bom.bom_lines and not bom.bom_components) or bom.bom_type in ('cutinput'))", addthis,not bom.bom_lines,not bom.bom_components,bom.bom_type)
                print addthis,bom.bom_lines,bom.bom_components,bom.bom_type
                if addthis and ((not bom.bom_lines and not bom.bom_components) or bom.bom_type in ('cutinput')):
                    print_tab(level,"*****ajout",bom.product_id.name)
                    proc_property_group = proc_ptr and [i.type_group_id.id for i in proc_ptr.group_property_ids] or []
                    property_group = list(set(proc_property_group) & set(no_filter))
                    bom_property_ids = []
                    for bom_ptr in bom_obj.browse(cr,uid,context["bom_tree"]+[bom.id]):
                        bom_property_ids.extend([i.id for i in bom_ptr.property_ids])
                    proc_property_ids = proc_ptr and [i.property_id.id for i in proc_ptr.group_property_ids if i.type_group_id.id in property_group] or []
                    property_ids = proc_ptr and [i.id for i in proc_ptr.property_ids] or []
                    property_ids = list(set(proc_property_ids) & set(property_ids))
                    property_ids += bom_property_ids
                    property_ids = list(set(property_ids))
                    group_property_ids = proc_ptr and [i.id for i in proc_ptr.group_property_ids if i.type_group_id.id in property_group ] or []
                    vals = {
                        'name': bom.product_id.name,
                        'product_id': bom.product_id.id,
                        'product_qty': bom.product_qty * factor,
                        'product_uom': bom.product_uom.id,
                        'product_uos_qty': bom.product_uos and bom.product_uos_qty * factor or False,
                        'product_uos': bom.product_uos and bom.product_uos.id or False,
                        'property_ids': [(6,0,property_ids)],
                        'group_property_ids': [(6,0,group_property_ids)],
                        'density':bom.density,
                        'diameter':bom.diameter,
                        'shape':bom.shape,
                        'size_x':bom.size_x,
                        'size_y':bom.size_y,
                        'size_z':bom.size_z,
                        'diameter':bom.diameter,
                        'weight':bom.weight,
                        'bom_id':bom.id,
                    } 
                    
                    print_tab(level,"++++++++++++++++++++++",)
                    if "bom_line" in context :
                        print_tab(level,"bom_line",context["bom_line"].bom_id.bom_type,context["bom_line"].bom_id.name)
                        if context["bom_line"].bom_id.bom_type not in ('cutinput') :
                            value_size = {
                                'size_x':bom.size_x,
                                'size_y':bom.size_y,
                                'size_z':bom.size_z,
                                'diameter':bom.diameter,
                                'specific_production': proc_ptr and proc_ptr.specific_production,
                                'note_production': proc_ptr and proc_ptr.note_production,
                                'size_x_specific': proc_ptr and proc_ptr.size_x_specific,
                                'size_y_specific': proc_ptr and proc_ptr.size_y_specific,
                                'size_z_specific': proc_ptr and proc_ptr.size_z_specific,
                                'diameter_specific': proc_ptr and proc_ptr.diameter_specific,
                                'size_x_specific_delta': proc_ptr and proc_ptr.size_x_specific_delta,
                                'size_y_specific_delta': proc_ptr and proc_ptr.size_y_specific_delta,
                                'size_z_specific_delta': proc_ptr and proc_ptr.size_z_specific_delta,
                                'diameter_specific_delta': proc_ptr and proc_ptr.diameter_specific_delta,
                            }
                            vals.update(context["bom_line"].compute_size(value_size)[context["bom_line"].id])
                            vals.update({
                                'shape':bom.shape,
                                'specific_production': proc_ptr and proc_ptr.specific_production,
                                'note_production': proc_ptr and proc_ptr.note_production,
                            })
                        else:
                            if proc_ptr:
                                value_size = {
                                    'size_x':proc_ptr.size_x,
                                    'size_y':proc_ptr.size_y,
                                    'size_z':proc_ptr.size_z,
                                    'diameter':proc_ptr.diameter,
                                    'specific_production': proc_ptr.specific_production,
                                    'note_production': proc_ptr.note_production,
                                    'size_x_specific': proc_ptr.size_x_specific,
                                    'size_y_specific': proc_ptr.size_y_specific,
                                    'size_z_specific': proc_ptr.size_z_specific,
                                    'diameter_specific': proc_ptr.diameter_specific,
                                    'size_x_specific_delta': proc_ptr.size_x_specific_delta,
                                    'size_y_specific_delta': proc_ptr.size_y_specific_delta,
                                    'size_z_specific_delta': proc_ptr.size_z_specific_delta,
                                    'diameter_specific_delta': proc_ptr.diameter_specific_delta,
                                }
                                vals.update(value_size)
                            
                    result.append(vals)
                else:
                    print_tab(level,"*****rec")
                    if bom.id not in context["bom_tree"]:
                        context["bom_tree"].append(bom.id)
                    for bom2 in bom.bom_lines:
                        print_tab(level,"\\"*50)
                        res = self._bom_explode(cr, uid, bom2, factor, properties, addthis=True, level=level+10, group_properties=group_properties, procurement_id=procurement_id, context=context)
                        print_tab(level,"/"*50)
                        result = result + res[0]
                        result2 = result2 + res[1]
                    for bom2 in bom.bom_components:
                        print_tab(level,"\\"*50)
                        context_child = context.copy()
                        context_child.update({'bom_line':bom2})
                        if bom2.component_id.id not in context["bom_tree"]:
                            print_tab(level,"explode")
                            res = self._bom_explode(cr, uid, bom2.component_id, factor, properties, addthis=True, level=level+10, group_properties=group_properties, procurement_id=procurement_id, context=context_child)
                            result = result + res[0]
                            result2 = result2 + res[1]
                        print_tab(level,"/"*50)
            #===================================================================
            # Bom with filter
            #===================================================================
            if filter :
                print_tab(level,"nomenclature avec filtre")
                match = False
                table_match = {}
                for child in proc_ptr.procurement_line:
                    print_tab(level,"check procuremnt")
                    print_tab(level,"filter",filter)
                    print_tab(level,"child.parent_option_id.type_group.id",child.parent_option_id.type_group.id)
                    print_tab(level,"child.parent_option_id.product_id",child.parent_option_id.product_id.id,child.parent_option_id.product_id.name)
                    print_tab(level,"bom.product_id",bom.product_id.id,bom.product_id.name)
                    
                    
                    if child.parent_option_id.type_group.id in filter and child.parent_option_id.product_id == bom.product_id:
                        print_tab(level,"ok")
                        if addthis or(not bom.bom_lines and not bom.bom_components):
                            print_tab(level,"*****ajout avec proc",bom.product_id.name)
                            bom_property_ids = []
                            for bom_ptr in bom_obj.browse(cr,uid,context["bom_tree"]+[bom.id]):
                                bom_property_ids.extend([i.id for i in bom_ptr.property_ids])
                            proc_property_ids = child and [i.property_id.id for i in child.group_property_ids if i.type_group_id.id in property_group] or []
                            property_ids = child and [i.id for i in child.property_ids] or []
                            property_ids = list(set(proc_property_ids) & set(property_ids))
                            property_ids += bom_property_ids
                            property_ids = list(set(property_ids))
                            result.append(
                            {
                                'name': bom.product_id.name,
                                'product_id': bom.product_id.id,
                                'product_qty': bom.product_qty * factor,
                                'product_uom': bom.product_uom.id,
                                'product_uos_qty': bom.product_uos and bom.product_uos_qty * factor or False,
                                'product_uos': bom.product_uos and bom.product_uos.id or False,
                                'property_ids': property_ids,
                                'group_property_ids': proc_property_ids,
                                'option_ids': [(6,0,[child.parent_option_id.id])],
                                'procurement_id': child.id,
                                'density':bom.density,
                                'shape':bom.shape,
                                'size_x':child.size_x_specific or bom.size_x,
                                'size_y':child.size_y_specific or bom.size_y,
                                'size_z':child.size_z_specific or bom.size_z,
                                'diameter':child.diameter_specific or bom.diameter,
                                'weight':bom.weight,
                            })
                        else:
                            print_tab(level,"*****rec", "addthis or(not bom.bom_lines and not bom.bom_components)",addthis,not bom.bom_lines,not bom.bom_components)
                            for bom2 in bom.bom_lines:
                                res = self._bom_explode(cr, uid, bom2, factor, properties, addthis=True, level=level+10, group_properties=group_properties, procurement_id=child.id, context=context)
                                result = result + res[0]
                                result2 = result2 + res[1]
                            for bom2 in bom.bom_components:
                                context_child = context.copy()
                                context_child.update({'bom_line':bom2})
                                res = self._bom_explode(cr, uid, bom2.component_id, factor, properties, addthis=True, level=level+10, group_properties=group_properties, procurement_id=child.id, context=context_child)
                                result = result + res[0]
                                result2 = result2 + res[1]
                    else:
                        print_tab(level,"!ok",child.parent_option_id.type_group.id , filter,child.parent_option_id.product_id,bom.product_id)
        else:
            #===================================================================
            # Add routing of bom phantom
            #===================================================================
             if bom.routing_id: 
                 for wc_use in bom.routing_id.workcenter_lines: 
                     wc = wc_use.workcenter_id 
                     d, m = divmod(factor, wc_use.workcenter_id.capacity_per_cycle) 
                     mult = (d + (m and 1.0 or 0.0)) 
                     cycle = mult * wc_use.cycle_nbr 
                     result2.append({ 
                         'name': bom.routing_id.name, 
                         'workcenter_id': wc.id, 
                         'sequence': level+(wc_use.sequence or 0), 
                         'cycle': cycle, 
                         'hour': float(wc_use.hour_nbr*mult + (wc.time_start+wc.time_stop+cycle*wc.time_cycle) * (wc.time_efficiency or 1.0)), 
                     }) 
        return result, result2
    
#        level_ = "-----------"+("-"*level)
#        if level == 50 : raise
#        print "*"*50
#        print level_+"***_bom_explode",level,bom.name,[ i.id for i in bom.bom_lines],[ i.component_id.id for i in bom.bom_components],addthis
#        production_obj = self.pool.get('mrp.production')
#        procurement_obj = self.pool.get('procurement.order')
#        
#        procurement = False
#        production = False
#        if procurement_id:
#            procurement = procurement_obj.browse(cr,uid,procurement_id)
#            if procurement.production_id:
#                production = procurement.production_id
#            
#        factor = factor / (bom.product_efficiency or 1.0)
#        factor = rounding(factor, bom.product_rounding)
#        if factor<bom.product_rounding:
#            factor = bom.product_rounding
#        result = []
#        result2 = []
#        result3 = []
#        phantom=False
#        match = False
#        no_rec = False
#        if bom.type=='phantom':
#            print level_+"phantom"
#            for bom2 in bom.bom_lines:
#                res = self._bom_explode(cr, uid, bom2, factor, properties, addthis=True, level=level+10, group_properties=group_properties, procurement_id=procurement_id)
#                result = result + res[0]
#                result2 = result2 + res[1]
#            for bom2 in bom.bom_components:
#                res = self._bom_explode(cr, uid, bom2.component_id, factor, properties, addthis=True, level=level+10, group_properties=group_properties, procurement_id=procurement_id)
#                result = result + res[0]
#                result2 = result2 + res[1]
#        else:
#            print level_+"not phantom",procurement,bom,bom.type_group_ids
#            filter = []
#            for i in bom.type_group_ids :
#                print i,i.name,i.execution_filter
#                if i.execution_filter :
#                    filter.append(i.id)
#            if filter :
#                if procurement and procurement.parent_option_id and procurement.parent_option_id.type_group :
#                    print level_+"proc group ",procurement.parent_option_id.type_group.id
#                print level_+"filter ",filter
#                if procurement and procurement.parent_option_id and procurement.parent_option_id.type_group and procurement.parent_option_id.type_group.id in filter:
#                    result.append(
#                    {
#                        'name': bom.product_id.name,
#                        'product_id': bom.product_id.id,
#                        'product_qty': bom.product_qty * factor,
#                        'product_uom': bom.product_uom.id,
#                        'product_uos_qty': bom.product_uos and bom.product_uos_qty * factor or False,
#                        'product_uos': bom.product_uos and bom.product_uos.id or False,
#                        'property_ids': [(6,0,[i.id for i in procurement.property_ids])],
#                        'group_property_ids': [(6,0,[i.id for i in procurement.group_property_ids])],
#                        'procurement_ids': [(4,procurement_id)],
#                    })
#                    no_rec = True
#            else:
#                if procurement :
#                    result.append(
#                    {
#                        'name': bom.product_id.name,
#                        'product_id': bom.product_id.id,
#                        'product_qty': bom.product_qty * factor,
#                        'product_uom': bom.product_uom.id,
#                        'product_uos_qty': bom.product_uos and bom.product_uos_qty * factor or False,
#                        'product_uos': bom.product_uos and bom.product_uos.id or False,
#                        'property_ids': [(6,0,[i.id for i in procurement.property_ids])],
#                        'group_property_ids': [(6,0,[i.id for i in procurement.group_property_ids])],
#                        'procurement_ids': [(4,procurement_id)],
#                    })
#                    no_rec = True
##                for bom2 in bom.bom_lines:
##                    if bom2.product_id.supply_method in ('produce'):
##                        if production:
##                            vals = {
##                                'name':'PROD2:'+production.name,
##                                'date_planned': production.date_planned,
##                                'product_id': bom2.product_id.id,
##                                'product_qty': bom2.product_qty,
##                                'product_uom': bom2.product_uom.id,
##                                'product_uos_qty': bom2.product_uos and line.product_uos_qty or False,
##                                'product_uos': bom2.product_uos and line.product_uos.id or False,
##                                'location_id': production.location_src_id.id,
##                                'location_dest_id': bom2.product_id.product_tmpl_id.property_stock_production.id,
###                                'move_dest_id': res_final_id,
##                                'state': 'waiting',
###                                'prodlot_id': line_prodlot_id,
##                            }
##                            result3.append(vals)
##                for bom2 in bom.bom_components:
##                    bom2=bom2.component_id
##                    if bom2.product_id.supply_method in ('produce'):
##                        if production:
##                            vals = {
##                                'name':'PROD2:'+production.name,
##                                'date_planned': production.date_planned,
##                                'product_id': bom2.product_id.id,
##                                'product_qty': bom2.product_qty,
##                                'product_uom': bom2.product_uom.id,
##                                'product_uos_qty': bom2.product_uos and line.product_uos_qty or False,
##                                'product_uos': bom2.product_uos and line.product_uos.id or False,
##                                'location_id': production.location_src_id.id,
##                                'location_dest_id': bom2.product_id.product_tmpl_id.property_stock_production.id,
###                                'move_dest_id': res_final_id,
##                                'state': 'waiting',
###                                'prodlot_id': line_prodlot_id,
##                            }
##                            result3.append(vals)
#        if not no_rec:
#            for bom2 in bom.bom_lines:
#                res = self._bom_explode(cr, uid, bom2, factor, properties, addthis=True, level=level+10)
#                result = result + res[0]
#                result2 = result2 + res[1]
#            for bom2 in bom.bom_components:
#                res = self._bom_explode(cr, uid, bom2.component_id, factor, properties, addthis=True, level=level+10, group_properties=group_properties, procurement_id=procurement_id)
#                result = result + res[0]
#                result2 = result2 + res[1]
#        print level_+"result ---------> ",result
#
#        return result, result2, []
    
    def gen_graph(self,cr,uid,ids,context):
        bom_node = []
        bom_link = []
        gen_graph_tab = []
        gen_graph_desc_tab = []
        gen_graph_asc_tab = []
        def gen_graph(bom):
#            print "gen_graph"
            result = ""
            if bom.id not in gen_graph_tab:
                gen_graph_tab.append(bom.id)
                result+=rec_gen_graph_desc(bom)
                result+=rec_gen_graph_asc(bom)
            return result
                
        def rec_gen_graph_desc(bom):
#            print "rec_gen_graph_desc"
            result = ""
            if bom.id not in bom_node:
                bom_node.append(bom.id)
                result += str(bom.id)+" [label=\""+bom.name+"\"] "+";\n"
            for line in bom.bom_components:
                if str(bom.id)+"_"+str(line.component_id.id) not in bom_link:
                    bom_link.append(str(bom.id)+"_"+str(line.component_id.id))
                    result += str(bom.id)+" -> "+str(line.component_id.id)+";\n"
                result += rec_gen_graph_desc(line.component_id)
                result += gen_graph(line.component_id)
            return result
                
        def rec_gen_graph_asc(bom):
#            print "rec_gen_graph_asc"
            result = ""
            if bom.id not in bom_node:
                bom_node.append(bom.id)
                result += str(bom.id)+" [label=\""+bom.name+"\"] "+";\n"
            for line in bom.bom_components_parent:
                if str(line.bom_id.id)+"_"+str(bom.id) not in bom_link:
                    bom_link.append(str(line.id)+"_"+str(bom.id))
                    result += str(line.bom_id.id)+" -> "+str(bom.id)+";\n"
                result += rec_gen_graph_asc(line.bom_id)
                result += gen_graph(line.bom_id)
            return result
                
        #print "digraph G {"
        #for bom in self.browse(cr,uid,ids,context):
        #    print gen_graph(bom)
        #print "}"
        return True
    
    def gen_graph_dot(self,cr,uid,ids,context={}):
        
        try:
            import pydot
        except Exception,e:
            _logger.notifyChannel('workflow', netsvc.LOG_WARNING,
                    'Import Error for pydot, you will not be able to render workflows\n'
                    'Consider Installing PyDot or dependencies: http://dkbza.org/pydot.html')
            raise e
    
        self.done = False
        
        graph = pydot.Dot(fontsize='16', label="""\\\n\\nBOM: """,
                          size='10.7, 7.3', center='1', ratio='auto', rotate='90', rankdir='LR'
                         )
        
        bom_node = []
        bom_link = []
        gen_graph_tab = []
        gen_graph_desc_tab = []
        gen_graph_asc_tab = []
        def gen_graph(bom):
            result = ""
            if bom.id not in gen_graph_tab:
                gen_graph_tab.append(bom.id)
                result+=rec_gen_graph_desc(bom)
#                result+=rec_gen_graph_asc(bom)
            return result
                
        def rec_gen_graph_desc(bom):
            result = ""
            if bom.id not in bom_node:
                bom_node.append(bom.id)
                args = {'label':bom.product_id and bom.product_id.default_code or "E"}
                graph.add_node(pydot.Node(str(bom.id), **args))
            for line in bom.bom_components:
                if str(bom.id)+"_"+str(line.component_id.id) not in bom_link:
                    bom_link.append(str(bom.id)+"_"+str(line.component_id.id))
                    label = "|"
                    for i in bom.type_group_ids :
                        if i.execution_filter:
                            if label :
                                label+= "|"
                            label+=  i.name
                    args = {'label':label}
                    graph.add_edge(pydot.Edge( str(bom.id) ,str(line.component_id.id), fontsize='10', **args))
                result += rec_gen_graph_desc(line.component_id)
#                result += gen_graph(line)
            return result
                
        def rec_gen_graph_asc(bom):
            result = ""
            if bom.id not in bom_node:
                bom_node.append(bom.id)
                args = {'label':bom.product_id and bom.product_id.default_code or "E"}
                graph.add_node(pydot.Node(str(bom.id), **args))
            for line in bom.bom_components_parent:
                if str(line.bom_id.id)+"_"+str(bom.id) not in bom_link:
                    bom_link.append(str(line.bom_id.id)+"_"+str(bom.id))
                    args = {'label':''}
                    graph.add_edge(pydot.Edge( str(line.bom_id.id) ,str(bom.id), fontsize='10', **args))
                result += rec_gen_graph_asc(line.bom_id)
#                result += gen_graph(line)
            return result
                

        for bom in self.browse(cr,uid,ids,context):
            gen_graph(bom)
        
        return graph

    

mrp_bom()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: