# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2007-2014 ASPerience SARL (<http://www.asperience.fr>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import fields,osv
import inspect

class mrp_production(osv.osv):
    _inherit = 'mrp.production'

    def _size(self, cr, uid, ids, field_name, arg, context):
       res = {}
       for proc in self.browse(cr, uid, ids):
           res[proc.id] = {'size_x': 0.0, 'size_y': 0.0, 'size_z': 0.0 , 'diameter': 0.0}
           if proc.product_id:
                res[proc.id]['size_x'] = proc.product_id.size_x or proc.product_id.product_tmpl_id.size_x_tmpl or 0.0
                res[proc.id]['size_y'] = proc.product_id.size_y or proc.product_id.product_tmpl_id.size_y_tmpl or 0.0
                res[proc.id]['size_z'] = proc.product_id.size_z or proc.product_id.product_tmpl_id.size_z_tmpl or 0.0
                res[proc.id]['diameter'] = proc.product_id.diameter or proc.product_id.product_tmpl_id.diameter_tmpl or 0.0
       return res
   
    def action_compute(self, cr, uid, ids, context={}):
        print "action_compute",ids,context
        results = []
        for production in self.browse(cr, uid, ids):
            cr.execute('delete from mrp_production_product_line where production_id=%s', (production.id,))
            cr.execute('delete from mrp_production_workcenter_line where production_id=%s', (production.id,))
            bom_point = production.bom_id
            bom_id = production.bom_id.id
            filter = []
            properties = []
            group_properties = []
            
            #Lors de la création du mrp.production, il faut s'assurer que tous les procurements sommés sur la production
            #ont les mêmes propriétés et les mêmes groupes de propriétés
            if production and production.procurement_ids and production.procurement_ids[0].parent_option_id and production.procurement_ids[0].parent_option_id.type_group :
                filter.append(production.procurement_ids[0].parent_option_id.type_group.id)
                group_properties = [i.id for i in production.procurement_ids[0].group_property_ids]
#            #===============================================================
#            # Création des lignes de production
#            #===============================================================
#            for procurement in production.procurement_ids:
#                if procurement.bom_id and procurement.bom_id.bom_type in ('cut'):
#                    vals = {
#                        'production_id': production.id,
#                        'procurement_id': procurement.id,
#                        'bom_id':procurement.move_id.prodlot_id.mrp_production_id.bom_id.id,
#                        
#                        'name': procurement.move_id.prodlot_id.mrp_production_id.bom_id.product_id.name,
#                        'product_id': procurement.move_id.prodlot_id.mrp_production_id.bom_id.product_id.id,
#                        'product_qty': procurement.move_id.prodlot_id.mrp_production_id.bom_id.product_qty,
#                        'product_uom': procurement.move_id.prodlot_id.mrp_production_id.bom_id.product_uom.id,
#                        'product_uos_qty': procurement.move_id.prodlot_id.mrp_production_id.bom_id.product_uos and bom.product_uos_qty * factor or False,
#                        'product_uos': procurement.move_id.prodlot_id.mrp_production_id.bom_id.product_uos and bom.product_uos.id or False,
#                        'property_ids': [i.id for i in procurement.property_ids],
#                        'group_property_ids': [i.id for i in procurement.group_property_ids],
#                        'density':procurement.move_id.prodlot_id.mrp_production_id.bom_id.density,
#                        'diameter':procurement.move_id.prodlot_id.mrp_production_id.bom_id.diameter,
#                        'shape':procurement.move_id.prodlot_id.mrp_production_id.bom_id.shape,
#                        'weight':procurement.move_id.prodlot_id.mrp_production_id.bom_id.weight,
#                        'size_x':procurement.size_x,
#                        'size_y':procurement.size_y,
#                        'size_z':procurement.size_z,
#                        'diameter':procurement.diameter,
#                        'specific_production': procurement.specific_production,
#                        'note_production': procurement.note_production,
#                        'size_x_specific': procurement.size_x_specific,
#                        'size_y_specific': procurement.size_y_specific,
#                        'size_z_specific': procurement.size_z_specific,
#                        'diameter_specific': procurement.diameter_specific,
#                        'size_x_specific_delta': procurement.size_x_specific_delta,
#                        'size_y_specific_delta': procurement.size_y_specific_delta,
#                        'size_z_specific_delta': procurement.size_z_specific_delta,
#                        'diameter_specific_delta': procurement.diameter_specific_delta,
#                    }
#                    self.pool.get('mrp.production.product.line').create(cr,uid,vals)
#                    procurement.move_id.write({'production_id':production.id})
                
            if not bom_point:
                bom_id = self.pool.get('mrp.bom')._bom_find(cr, uid, production.product_id.id, production.product_uom.id, properties, filter)
                if bom_id:
                    bom_point = self.pool.get('mrp.bom').browse(cr, uid, bom_id)
                    routing_id = bom_point.routing_id.id or False
                    self.write(cr, uid, [production.id], {'bom_id': bom_id, 'routing_id': routing_id})

            if not bom_id:
                raise osv.except_osv(_('Error'), _("Couldn't find bill of material for product %s,%s: production %s,%s" % (production.product_id.name,str(production.product_id.id),production.name,str(production.id)) ) )

            #if bom_point.routing_id and bom_point.routing_id.location_id:
            #   self.write(cr, uid, [production.id], {'location_src_id': bom_point.routing_id.location_id.id})
            
            factor = production.product_qty * production.product_uom.factor / bom_point.product_uom.factor
            print "production.procurement_ids[0]",production.procurement_ids[0]
            res = self.pool.get('mrp.bom')._bom_explode(cr, uid, bom_point, factor / bom_point.product_qty, properties, group_properties=group_properties, procurement_id=production.procurement_ids[0].id or False)
            results = res[0]
            results2 = res[1]
            print "1111111111"
            for line in results:
                print line
                line['production_id'] = production.id
                self.pool.get('mrp.production.product.line').create(cr, uid, line)
            print "2222222222"
            for line in results2:
                print line
                line['production_id'] = production.id
                self.pool.get('mrp.production.workcenter.line').create(cr, uid, line)
        return len(results)

    def action_confirm(self, cr, uid, ids):
#        print "action_confirm stock.production"
        lot_obj = self.pool.get('stock.production.lot')
        picking_obj = self.pool.get('stock.picking')
        move_obj = self.pool.get('stock.move')
        
        picking_id=False
        proc_ids = []
        for production in self.browse(cr, uid, ids):
            #===================================================================
            # Test production déjà confirmé
            #===================================================================
            if production.state in ('confirmed'):
                picking_id = production.picking_id.id
                continue
            #===================================================================
            # Compute si pas déjà fait
            #===================================================================
            if not production.product_lines:
                self.action_compute(cr, uid, [production.id])
                production = self.browse(cr, uid, [production.id])[0]
            #===================================================================
            # Init des variables
            #===================================================================
            moves = []
            routing_loc = None
            pick_type = 'internal'
            address_id = False
            company = self.pool.get('res.users').browse(cr, uid, uid).company_id
            source = production.product_id.product_tmpl_id.property_stock_production.id
            if production.bom_id.routing_id and production.bom_id.routing_id.location_id:
                routing_loc = production.bom_id.routing_id.location_id
                if routing_loc.usage<>'internal':
                    pick_type = 'out'
                address_id = routing_loc.address_id and routing_loc.address_id.id or False
                routing_loc = routing_loc.id
                
            #===================================================================
            # Creation du picking de sortie
            #===================================================================
            vals = {
                'origin': (production.origin or '').split(':')[0] +':'+production.name,
                'type': pick_type,
                'move_type': 'one',
                'state': 'auto',
                'address_id': address_id,
                'partner_shipping_id':address_id,
                'auto_picking': self._get_auto_picking(cr, uid, production),
            }
            picking_id = picking_obj.create(cr, uid, vals)
            print_tab("*"*50)
            print_tab("Creation du picking de sortie")
            print_tab(vals)
            #===================================================================
            # Rehcherche du lot + Creation du lot s'il n'éxiste pas 
            #===================================================================
            vals = {
                'product_id': production.product_id.id,
                'date': datetime.datetime.now(),
                'mrp_production_id': production.id,
                'property_ids': production.procurement_ids and [(6,0,[i.id for i in production.procurement_ids[0].property_ids])] or [(6,0,[])],
                'group_property_ids': production.procurement_ids and [(6,0,[i.id for i in production.procurement_ids[0].group_property_ids])] or [(6,0,[])],
                'option_ids': production.procurement_ids and production.procurement_ids[0].parent_option_id and [(6,0,[ production.procurement_ids[0].parent_option_id.id ])] or [(6,0,[])],
                'density': production.bom_id.density,
                'diameter': production.bom_id.diameter,
                'shape': production.bom_id.shape,
                'size_x': production.procurement_ids[0].size_x_specific or production.bom_id.size_x,
                'size_y': production.procurement_ids[0].size_y_specific or production.bom_id.size_y,
                'size_z': production.procurement_ids[0].size_z_specific or production.bom_id.size_z,
                'weight': production.bom_id.weight,
            }
            prodlot_id = lot_obj.search_specific(cr,uid,vals,company.tracking_production_delay)
            if not prodlot_id:
                vals['name'] = self.pool.get('ir.sequence').get(cr, uid, 'stock.lot.serial')
                prodlot_id = lot_obj.create(cr, uid, vals)
            revision_id = self.pool.get('stock.production.lot.revision').create(cr, uid, {
                 'name': (production.origin or '').split(':')[0] +':'+production.name,
                 'description': (production.origin or '').split(':')[0] +':'+production.name,
                 'date': datetime.datetime.now(),
                 'author_id': uid,
                 'lot_id': prodlot_id,
            })
            #===================================================================
            # Update des moves
            #===================================================================
            self.pool.get('stock.move').write(cr, uid, [i.move_id.id for i in production.procurement_ids if not i.move_id.prodlot_id], {
                'prodlot_id': prodlot_id,
            })
            
            
            print_tab("*"*50)
            print_tab("production",production)
            print_tab("production",production.procurement_ids)
            print_tab("*"*50)
#            raise

            #===================================================================
            # Creation des lignes de workcenter
            #===================================================================
            if production.bom_id and production.bom_id.routing_id:
                print production.bom_id 
                for wc_use in production.bom_id.routing_id.workcenter_lines:
                    wc = wc_use.workcenter_id
                    factor = production.product_qty * production.product_uom.factor / production.bom_id.product_uom.factor
                    d, m = divmod(factor, wc_use.workcenter_id.capacity_per_cycle)
                    mult = (d + (m and 1.0 or 0.0))
                    cycle = mult * wc_use.cycle_nbr
                    move_ids = []
                    
                    self.pool.get('mrp.production.workcenter.line').create(cr,uid,{
                        'production_id': production.id,
                        'name': production.bom_id.routing_id.name,
                        'workcenter_id': wc.id,
                        'sequence': wc_use.sequence or 0,
                        'cycle': cycle,
                        'hour': float(wc_use.hour_nbr*mult + (wc.time_start+wc.time_stop+cycle*wc.time_cycle) * (wc.time_efficiency or 1.0)),
                        'move_ids': [(6,0,move_ids)],
                    })   
            
            #===================================================================
            # Creation du mouvement de sortie
            #===================================================================
            # TODO : voir pourquoi le picking il n'est pas relié au picking de sortie créé plus haut
            
            res_final_id = False
            if production.bom_id.bom_type in ('cut'):
                for proc in production.procurement_ids:
                    if proc.move_id.id:
                        res_final_id = proc.move_id.id
                        vals = {
                            'production_id':production.id,
                        }
                        move_obj.write(cr, uid, res_final_id, vals)
            else:
                vals = {
                    'name':'PROD1:'+production.name,
                    'date_planned': production.date_planned,
                    'product_id': production.product_id.id,
                    'product_qty': production.product_qty,
                    'product_uom': production.product_uom.id,
                    'product_uos_qty': production.product_uos and production.product_uos_qty or False,
                    'product_uos': production.product_uos and production.product_uos.id or False,
                    'location_id': source,
                    'location_dest_id': production.location_dest_id.id,
                    'move_dest_id': production.move_prod_id.id,
                    'state': 'waiting',
                    'prodlot_id': prodlot_id,
                    'production_id':production.id,
                }
                res_final_id = move_obj.create(cr, uid, vals)
                print_tab("*"*50)
                print_tab("Creation du mouvement de sortie")
                print_tab(vals)
            
#            self.write(cr, uid, [production.id], {'move_created_ids': [(6, 0, [res_final_id])]})
            
            #===================================================================
            # Parcours des ligne de production
            #===================================================================
            for line in production.product_lines:
                move_id = False
                line_prodlot_id = False
#                production_id = False
                #===============================================================
                # Test if bom is assemble or disassemble 
                #===============================================================
                print "--------------",line.bom_id.bom_type
                if production.bom_id.bom_type in ('cutinput'):
                    product_id = production.product_id.id
                else:
                    product_id = line.product_id.id
                    
                if line.product_id.type in ('product', 'consu'):
                    #===========================================================
                    # Recherche du lot, création d'il n'éxiste pas
                    #===========================================================
                    vals = {
                        'product_id': product_id,
                        'date': datetime.datetime.now(),
                        'mrp_production_id': production.id,
                        'property_ids': [(6,0,[i.id for i in line.property_ids])] or [(6,0,[])],
                        'group_property_ids': [(6,0,[i.id for i in line.group_property_ids])] or [(6,0,[])],
                        'option_ids': [(6,0,[i.id for i in line.option_ids])] or [(6,0,[])],
                        'density':line.density,
                        'diameter':line.specific_production and line.diameter_specific or line.diameter,
                        'shape':line.shape,
                        'size_x': line.specific_production and line.size_x_specific or line.size_x,
                        'size_y': line.specific_production and line.size_y_specific or line.size_y,
                        'size_z': line.specific_production and line.size_z_specific or line.size_z,
                        'weight':line.weight,
                    }
                    if line.procurement_id :
                        line_prodlot_id = line.procurement_id.move_id.prodlot_id.id
                    if not line_prodlot_id:
                        vals['name'] = self.pool.get('ir.sequence').get(cr, uid, 'stock.lot.serial')
                        line_prodlot_id = lot_obj.search_specific(cr,uid,vals,company.tracking_production_delay)
                    if not line_prodlot_id:
                        line_prodlot_id = lot_obj.create(cr, uid, vals)
                    revision_id = self.pool.get('stock.production.lot.revision').create(cr, uid, {
                         'name': (production.origin or '').split(':')[0] +':'+production.name,
                         'description': (production.origin or '').split(':')[0] +':'+production.name,
                         'date': datetime.datetime.now(),
                         'author_id': uid,
                         'lot_id': line_prodlot_id,
                    })
                    
#                    #===========================================================
#                    # Recuperation de la production en cours associé au lot
#                    #===========================================================
#                    if line_prodlot_id and line.bom_id.bom_type in ('cut'):
#                        move_ids = move_obj.search(cr,uid,[('prodlot_id','=',line_prodlot_id),('production_id','!=',False),('production_id.state','=','confirmed')])
#                        if move_ids:
#                            production_id = move_obj.read(cr,uid,move_ids)[0]['production_id'][0]
                    #===========================================================
                    # Recherche ou creation du move de sortie + enregistrement sur la production en entrée
                    #===========================================================
                    if not line.procurement_id :
                        vals = {
                            'name':'PROD22:'+production.name,
                            'date_planned': production.date_planned,
                            'product_id': product_id,
                            'product_qty': line.product_qty,
                            'product_uom': line.product_uom.id,
                            'product_uos_qty': line.product_uos and line.product_uos_qty or False,
                            'product_uos': line.product_uos and line.product_uos.id or False,
                            'location_id': routing_loc or production.location_src_id.id,
                            'location_dest_id': source,
                            'move_dest_id': res_final_id,
                            'state': 'waiting',
                            'prodlot_id': line_prodlot_id,
                        }
                        res_dest_id = self.pool.get('stock.move').create(cr, uid, vals)
                        moves.append(res_dest_id)
                        print_tab("/"*50)
                        print_tab("creation du move de sortie de ligne")
                        print_tab(vals)
                    else:
                        res_dest_id = line.procurement_id.move_id.id 
                    self.write(cr, uid, [production.id], {'move_lines': [(4,res_dest_id)]})
                    #===========================================================
                    # Création du move suivant le move de production
                    #===========================================================
                    vals = {
                        'name':'PROD3:'+production.name,
                        'picking_id':picking_id,
                        'product_id': product_id,
                        'product_qty': line.product_qty,
                        'product_uom': line.product_uom.id,
                        'product_uos_qty': line.product_uos and line.product_uos_qty or False,
                        'product_uos': line.product_uos and line.product_uos.id or False,
                        'date_planned': production.date_planned,
                        'move_dest_id': res_dest_id,
                        'location_id': production.location_src_id.id,
                        'location_dest_id': routing_loc or production.location_src_id.id,
                        'state': 'waiting',
                        'prodlot_id': line_prodlot_id,
#                        'production_id': production_id,
                    }
                    print_tab("Création du move suivant le move de sortie")
                    print_tab(vals)
                    move_id = self.pool.get('stock.move').create(cr, uid, vals)
                #===============================================================
                # Création du procurement pour la ligne s'il n'éxiste pas + update de la ligne
                #===============================================================
                if not line.procurement_id :
#                    production_id = False
                    vals = {
                        'name': (production.origin or '').split(':')[0] + ':' + production.name,
                        'origin': (production.origin or '').split(':')[0] + ':' + production.name,
                        'date_planned': production.date_planned,
                        'product_id': line.product_id.id,
                        'product_qty': line.product_qty,
                        'product_uom': line.product_uom.id,
                        'product_uos_qty': line.product_uos and line.product_qty or False,
                        'product_uos': line.product_uos and line.product_uos.id or False,
                        'property_ids': [(6,0,[i.id for i in line.property_ids])],
                        'group_property_ids': [(6,0,[i.id for i in line.group_property_ids])],
                        'option_ids': [(6,0,[i.id for i in line.option_ids])],
                        'size_x':line.size_x,
                        'size_y':line.size_y,
                        'size_z':line.size_z,
                        'diameter':line.diameter,
                        'specific_production': line.specific_production,
                        'note_production': line.note_production,
                        'size_x_specific': line.size_x_specific,
                        'size_y_specific': line.size_y_specific,
                        'size_z_specific': line.size_z_specific,
                        'diameter_specific': line.diameter_specific,
                        'size_x_specific_delta': line.size_x_specific_delta,
                        'size_y_specific_delta': line.size_y_specific_delta,
                        'size_z_specific_delta': line.size_z_specific_delta,
                        'diameter_specific_delta': line.diameter_specific_delta,
                        'location_id': production.location_src_id.id,
                        'procure_method': line.product_id.procure_method,
                        'move_id': move_id,
                        'bom_id': line.bom_id and line.bom_id.id or False,
#                        'production_id':production_id,
                    }
                    proc_id = self.pool.get('procurement.order').create(cr, uid, vals)
                    print_tab("Création du procurement")
                    print_tab(vals)
                    self.pool.get('mrp.production.product.line').write(cr, uid, line.id, {'procurement_id':proc_id})
                    #===========================================================
                    # Validation du procurement
                    #===========================================================
                    wf_service = netsvc.LocalService("workflow")
                    wf_service.trg_validate(uid, 'procurement.order', proc_id, 'button_confirm', cr)
                    proc_ids.append(proc_id)
            #===================================================================
            # Validation du picking de sortie
            #===================================================================
            wf_service = netsvc.LocalService("workflow")
            wf_service.trg_validate(uid, 'stock.picking', picking_id, 'button_confirm', cr)
            self.write(cr, uid, [production.id], {'picking_id':picking_id, 'state':'confirmed'})
#        raise
        return picking_id

    _columns = {
        'procurement_ids': fields.one2many('procurement.order', 'production_id', 'Procurements'),
        'specific_production':fields.boolean('Specific Production'),
        'note_production':fields.text('Production Note'),
        'size_x': fields.function(_size, multi="size", method=True, string='Width', digits=(16, 5), type='float'),
        'size_y': fields.function(_size, multi="size", method=True, string='Length', digits=(16, 5), type='float'),
        'size_z': fields.function(_size, multi="size", method=True, string='Thickness', digits=(16, 5), type='float'),
        'diameter': fields.function(_size, multi="size", method=True, string='Diameter', digits=(16, 5), type='float'),
        'size_x_specific': fields.float('Width specific', digits=(16, 5), readonly=True),
        'size_y_specific': fields.float('Length specific', digits=(16, 5), readonly=True),
        'size_z_specific': fields.float('Thickness specific', digits=(16, 5), readonly=True),
        'diameter_specific': fields.float('Diameter specific', digits=(16, 5), readonly=True),
        'size_x_specific_delta': fields.float('Width specific delta', digits=(16, 5), readonly=True),
        'size_y_specific_delta': fields.float('Length specific delta', digits=(16, 5), readonly=True),
        'size_z_specific_delta': fields.float('Thickness specific delta', digits=(16, 5), readonly=True),
        'diameter_specific_delta': fields.float('Diameter specific delta', digits=(16, 5), readonly=True),
    }
    _order = 'id desc'
    
    def action_production_end(self, cr, uid, ids):
#        move_ids = []
        for production in self.browse(cr, uid, ids):
            for res in production.move_lines:
                for move in production.move_created_ids:
                    #XXX must use the orm
#                    cr.execute('INSERT INTO stock_move_history_ids \
#                            (parent_id, child_id) VALUES (%s,%s)',
#                            (res.id, move.id))
                    #ASPerience: test des valeurs pour éviter les erreurs de réécriture
                    cr.execute('select parent_id,child_id from stock_move_history_ids where parent_id=%s and child_id=%s', (res.id, move.id))
                    if len(cr.fetchall()) == 0:
                        cr.execute('insert into stock_move_history_ids (parent_id,child_id) values (%s,%s)', (res.id, move.id))
                    else:
                        logger = netsvc.Logger()
                        logger.notifyChannel("warning", netsvc.LOG_WARNING," ERROR insert into stock_move_history_ids parent_id=%s and child_id=%s'." % (str(move.id), str(move.move_dest_id.id)))
                    #Fin ASPerience
#                move_ids.append(res.id)
            vals= {'state':'confirmed'}
            new_moves = [x.id for x in production.move_created_ids]
            self.pool.get('stock.move').write(cr, uid, new_moves, vals)
            if not production.date_finnished:
                self.write(cr, uid, [production.id],
                        {'date_finnished': time.strftime('%Y-%m-%d %H:%M:%S')})
            self.pool.get('stock.move').check_assign(cr, uid, new_moves)
            self.pool.get('stock.move').action_done(cr, uid, new_moves)
            self._costs_generate(cr, uid, production)
#        self.pool.get('stock.move').action_done(cr, uid, move_ids)
        self.write(cr,  uid, ids, {'state': 'done'})
        return True

mrp_production()
    
class mrp_production_product_line(osv.osv):
    _inherit = 'mrp.production.product.line'
    
    _columns = {
        #Properties
        'property_ids': fields.many2many('mrp.property', 'mrp_production_product_line_property_rel', 'line_id','property_id', 'Properties'),
        'group_property_ids': fields.many2many('mrp.property.group.option', 'mrp_production_line_group_property_rel','production_line_id', 'group_id', 'Product Property Group Rel '),
        'procurement_id': fields.many2one('procurement.order', 'Procurement'),
        'option_ids': fields.many2many('product.links', 'mrp_production_product_line_options_rel','line_id', 'links_id', 'Option'),
        'bom_id': fields.many2one('mrp.bom', 'Bom'),
        #Dimensions
        'size_x': fields.float('Width', digits=(16, 5)),
        'size_y': fields.float('Lenght', digits=(16, 5)),
        'size_z': fields.float('Thickness', digits=(16, 5)),
        'density': fields.float('Density', digits=(16, 5)),
        'shape' : fields.selection([('quadrangular', 'Quadrangular'), ('cylindrical', 'Cylindrical'), ('other', 'Other')], 'Shape', required=True),
        'diameter' : fields.float('Diameter', digits=(16, 5)),
        'weight': fields.float('Weight', digits=(16, 5)),
        'specific_production':fields.boolean('Specific Production'),
        'note_production':fields.text('Production Note'),
        'size_x_specific': fields.float('Width specific', digits=(16, 5), readonly=True ),
        'size_y_specific': fields.float('Length specific', digits=(16, 5), readonly=True),
        'size_z_specific': fields.float('Thickness specific', digits=(16, 5), readonly=True),
        'diameter_specific': fields.float('Diameter specific', digits=(16, 5), readonly=True),
        'size_x_specific_delta': fields.float('Width specific delta', digits=(16, 5), readonly=True),
        'size_y_specific_delta': fields.float('Length specific delta', digits=(16, 5), readonly=True),
        'size_z_specific_delta': fields.float('Thickness specific delta', digits=(16, 5), readonly=True),
        'diameter_specific_delta': fields.float('Diameter specific delta', digits=(16, 5), readonly=True),

        'uom_d_size' : fields.related('product_id', 'uom_d_size', help="Default united of measure density used for operations size to cube"),
        'uom_d_weight': fields.related('product_id', 'uom_d_weight', help="Default united of measure density used for operations weight"),
        'uom_s_size' : fields.related('product_id', 'uom_s_size', help="Default united of measure used for operations size"),
    }
    _defaults = {
        'shape': lambda * a: 'other',
    }

    def onchange_product_id(self, cr, uid, ids, product_id, context={}):
        if product_id:
            w = self.pool.get('product.product').browse(cr, uid, product_id, context)
            factor1 = w.uom_d_weight.factor
            factor2 = w.uom_id.factor
            factor3 = w.uom_d_size.factor
            factor4 = w.uom_s_size.factor                       
            v = {
                'product_uom':w.uom_id.id,
                'product_uos':w.uos_id and w.uos_id.id or w.uom_id.id,
                'size_x':w.size_x or w.size_x_tmpl,
                'size_y':w.size_y or w.size_y_tmpl,
                'size_z':w.size_z or w.size_z_tmpl,
                'density':w.density or w.density_tmpl,
                'shape':w.shape,
                'diameter':w.diameter or w.diameter_tmpl,
                'weight':compute_w(cr, uid, factor1, factor2, factor3, factor4, w.size_x or w.size_x_tmpl, w.size_y or w.size_y_tmpl, w.size_z or w.size_z_tmpl, w.shape, w.density or w.density_tmpl, w.diameter or w.diameter_tmpl)['weight'] 
            }
            return {'value': v}
        return {}

    def compute_weight(self, cr, uid, id, product_id, size_x, size_y, size_z, shape, density, diameter):
       if product_id:
           product = self.pool.get('product.product').browse(cr, uid, product_id, context='')
           factor1 = product.uom_d_weight.factor
           factor2 = product.uom_id.factor
           factor3 = product.uom_d_size.factor
           factor4 = product.uom_s_size.factor           
           return {'value': compute_w(cr, uid, factor1, factor2, factor3, factor4, size_x, size_y, size_z, shape, density, diameter)}

mrp_production_product_line()

class mrp_production_workcenter_line(osv.osv):
    _inherit = 'mrp.production.workcenter.line'
    _columns = {
        'move_ids' : fields.many2many('stock.move', 'mrp_production_workcenter_line_stock_move_rel', 'line_id', 'move_id', 'Moves'),
    }
    _defaults = {
    }
mrp_production_workcenter_line()

def print_tab(*args):
    cc = 0
    try:
        tmp = inspect.stack()[1]
        for i in tmp[4][0]:
            if i == ' ':
                cc+=1
            else:
                break
        
        if isinstance(args[0],int):
            print "-"*args[0],
            args = args[1:]
        print str(tmp[2]).ljust(4),
        print " "*cc,
    except:
        pass
    for i in args:
        print i,
    print 
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: