# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2007-2014 ASPerience SARL (<http://www.asperience.fr>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import fields,osv
#import openerp.netsvc
#import time
#import datetime
#from mx import DateTime
#from openerp.tools.translate import _
#from openerp.tools import ustr

class mrp_property_group_option(osv.osv):
    _name = 'mrp.property.group.option'
    _description = 'GOP / Property'
    _columns = {
        'name': fields.char('Name', size=256, required=True),
        'type_group_id': fields.many2one('product.type.property.option', 'GOP', required=True),
        'property_id': fields.many2one('mrp.property', 'Property', required=True),
    }
    _defaults = {
    }
    
    def onchange_group_property(self, cr, uid, id, type_group_id, property_id):
        res = {'value':{}}
        if type_group_id and not property_id :
            type_group = self.pool.get("product.type.property.option").browse(cr,uid,type_group_id)
            res['value']['name'] = type_group.name+"[X]"
        elif not type_group_id and property_id :
            property = self.pool.get("mrp.property").browse(cr,uid,property_id)
            res['value']['name'] = "X["+property.name+"]"
        elif type_group_id and property_id :
            type_group = self.pool.get("product.type.property.option").browse(cr,uid,type_group_id)
            property = self.pool.get("mrp.property").browse(cr,uid,property_id)
            res['value']['name'] = type_group.name+"["+property.name+"]"
        return res
    
mrp_property_group_option()

class mrp_property_group(osv.osv):
    _inherit = 'mrp.property.group'
    _columns = {
        'property_ids': fields.one2many('mrp.property', 'group_id', 'Properties'),
    }
    _defaults = {
    }
mrp_property_group()

class mrp_property(osv.osv):
    _inherit = 'mrp.property'
    
    def name_get(self, cr, uid, ids, context=None):
        if not ids:
            return []
        reads = self.read(cr, uid, ids, ['name','code'], context)
        res = []
        for record in reads:
            name = "[%s] %s" % (record['code'],record['name'])
            res.append((record['id'], name))
        return res
    
    _columns = {
        'code': fields.char('Code', size=64, required=True),
        'price': fields.float('Price'),
        'size_x_tmpl': fields.float('Width', digits=(16, 5)),
        'size_y_tmpl': fields.float('Length', digits=(16, 5)),
        'size_z_tmpl': fields.float('Thickness', digits=(16, 5)),
        'diameter_tmpl': fields.float('Diameter', digits=(16, 5)),
        'uom_s_size_tmpl' : fields.many2one('product.uom', 'Size Uom', help="Default united of measure used for operations size"),
    }
    _defaults = {
        'code': lambda *a: 'XXX',
        'price': lambda *a: 0.0,
        'size_x_tmpl': lambda *a: 0,
        'size_y_tmpl': lambda *a: 0,
        'size_z_tmpl': lambda *a: 0,
        'diameter_tmpl': lambda *a: 0,
        'composition': lambda *a: 'plus',
    }
mrp_property()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: