# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2007-2014 ASPerience SARL (<http://www.asperience.fr>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import fields,osv

class mrp_routing(osv.osv):
    _inherit = 'mrp.routing'
    _columns = {
        'technical_data': fields.char('Technical Data', size=128),
    }
    _defaults = {
        'active': lambda *a: 1,
    }
mrp_routing()

class mrp_routing_workcenter_subproduct(osv.osv):
    _name = 'mrp.routing.workcenter.subproduct'
    _description = 'mrp.routing.workcenter.subproduct'
    _columns = {
        'name': fields.float('Percent', required=True),
        'subproduct_id': fields.many2one('mrp.subproduct', 'Subproduct', required=True),
        'workcenter_line_id': fields.many2one('mrp.routing.workcenter', 'Routing Workcenter', required=True),
    }
mrp_routing_workcenter_subproduct()

class mrp_routing_workcenter(osv.osv):
    _inherit = 'mrp.routing.workcenter'
    _columns = {
        'sub_ids': fields.one2many('mrp.routing.workcenter.subproduct', 'workcenter_line_id', 'Sub Product'),
        'bom_ids': fields.many2many('mrp.bom', 'routing_workcenter_mrp_bom_rel', 'workcenter_line_id', 'bom_id', 'Components'),
    }
    _defaults = {
    }
mrp_routing_workcenter()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: