# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2007-2014 ASPerience SARL (<http://www.asperience.fr>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import fields,osv

class mrp_subproduct(osv.osv):
    _inherit = 'mrp.subproduct'
    _columns={
          'product_efficiency': fields.float('Manufacturing Efficiency', required=True, help="A factor of 0.9 means a loss of 10% within the production process."),
          'efficiency_rounding': fields.selection([(1,'1'),(2,'0.1'),(3,'0.01'),(4,'0.001'),(5,'0.0001'),(5,'0.00001')], 'Efficiency rounding', required=True, help= "todo" ),
          'type_group_ids': fields.many2many('product.type.property.option', 'mrp_subproduct_options_rel', 'subproduct_id', 'type_id', 'Group by (GOP)',help="Used to map which property option is taken from main product in dissambly chain"),
    }
    _defaults={
        'product_efficiency' : lambda *a : 1,
        'efficiency_rounding' : lambda *a : 2,
    }
mrp_subproduct()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: