# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2007-2014 ASPerience SARL (<http://www.asperience.fr>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import fields,osv
#import openerp.netsvc
#import time
#import datetime
#from mx import DateTime
#from openerp.tools.translate import _
#from openerp.tools import ustr

class procurement_order(osv.osv):
    _inherit = 'procurement.order'
    
    def _size(self, cr, uid, ids, field_name, arg, context):
       res = {}
       for proc in self.browse(cr, uid, ids):
           res[proc.id] = {'size_x': 0.0, 'size_y': 0.0, 'size_z': 0.0 ,'diameter': 0.0}
           if proc.product_id:
                res[proc.id]['size_x'] = proc.product_id.size_x or proc.product_id.product_tmpl_id.size_x_tmpl or 0.0
                res[proc.id]['size_y'] = proc.product_id.size_y or proc.product_id.product_tmpl_id.size_y_tmpl or 0.0
                res[proc.id]['size_z'] = proc.product_id.size_z or proc.product_id.product_tmpl_id.size_z_tmpl or 0.0
                res[proc.id]['diameter'] = proc.product_id.diameter or proc.product_id.product_tmpl_id.diameter_tmpl or 0.0
       return res

    def get_production(self, cr, uid, ids, context={}):
        production_obj = self.pool.get('mrp.production')
        move_obj = self.pool.get('stock.move')
        result = {}
        for procurement in self.browse(cr, uid, ids):
            result[procurement.id] = False
            if procurement.bom_id and procurement.bom_id.bom_type in ('cut'):
                print "procurement.bom_id",procurement.bom_id,procurement.bom_id.bom_type
                production_id = production_obj.search(cr,uid,[('bom_id','=',procurement.bom_id.id),('state','=','draft')])
                
                if production_id:
                    result[procurement.id] = production_id[0]
                    self.write(cr,uid,procurement.id,{'production_id':result[procurement.id]})
                    move_obj.write(cr,uid,procurement.move_id.id,{'production_id':result[procurement.id]})
                    
#                if procurement.move_id.prodlot_id:
#                    print procurement.move_id.prodlot_id
#                    move_ids = move_obj.search(cr,uid,[('prodlot_id','=',procurement.move_id.prodlot_id.id),('production_id','!=',False),('production_id.state','=','confirmed')])
#                    print move_ids
#                    if move_ids:
#                        production_id = move_obj.read(cr,uid,move_ids)[0]['production_id'][0]
#                        result[procurement.id] = production_id
#                        print "ok"
#                        self.write(cr,uid,procurement.id,{'production_id':production_id})

#            property_ids = [i.id for i in procurement.property_ids]
#            property_ids.sort()
#            production_ids = production_obj.search(cr,uid,[('state','=','draft'),('product_id','=',procurement.product_id.id),('bom_id.bom_type','=','cut')])
#            if production_ids:
#                production_ptr = production_obj.browse(cr,uid,production_ids,context)
#                print "",production_ptr.name
#                print "",production_ptr.move_ids
#                result[procurement.id] = 

#                if line_prodlot_id and line.bom_id.bom_type in ('cut'):
#                    move_ids = move_obj.search(cr,uid,[('prodlot_id','=',line_prodlot_id),('production_id','!=',False),('production_id.state','=','confirmed')])
#                    if move_ids:
#                        production_id = move_obj.read(cr,uid,move_ids)[0]['production_id'][0]
        return result
        
    def action_produce_assign_product(self, cr, uid, ids, context={}):
        print "action_produce_assign_product nouveau"
        wf_service = netsvc.LocalService("workflow")
        move_obj = self.pool.get('stock.move')
        produce_id = False
        company = self.pool.get('res.users').browse(cr, uid, uid, context).company_id
        result = {}
        production_ids = self.get_production(cr,uid,ids,context)
        for procurement in self.browse(cr, uid, ids):
            res_id = procurement.move_id.id
            loc_id = procurement.location_id.id
            newdate = DateTime.strptime(procurement.date_planned, '%Y-%m-%d %H:%M:%S') - DateTime.RelativeDateTime(days=procurement.product_id.product_tmpl_id.produce_delay or 0.0)
            newdate = newdate - DateTime.RelativeDateTime(days=company.manufacturing_lead)
            print production_ids[procurement.id]
            if production_ids[procurement.id]:
                result[procurement.id] = production_ids[procurement.id]
            else:
#            if not procurement.production_id:
                result[procurement.id] = self.pool.get('mrp.production').create(cr, uid, {
                    'origin': procurement.origin,
                    'product_id': procurement.product_id.id,
                    'product_qty': procurement.product_qty,
                    'product_uom': procurement.product_uom.id,
                    'product_uos_qty': procurement.product_uos and procurement.product_uos_qty or False,
                    'product_uos': procurement.product_uos and procurement.product_uos.id or False,
                    'location_src_id': procurement.location_id.id,
                    'location_dest_id': procurement.move_id.location_id.id,
                    'bom_id': procurement.bom_id and procurement.bom_id.id or False,
                    'date_planned': newdate.strftime('%Y-%m-%d %H:%M:%S'),
                    'move_prod_id': res_id,
                    'procurement_id': procurement.id,
                    'specific_production': procurement.specific_production,
                    'note_production': procurement.note_production,
                    'size_x_specific': procurement.size_x_specific,
                    'size_y_specific': procurement.size_y_specific,
                    'size_z_specific': procurement.size_z_specific,
                    'diameter_specific': procurement.diameter_specific,
                    'size_x_specific_delta': procurement.size_x_specific_delta,
                    'size_y_specific_delta': procurement.size_y_specific_delta,
                    'size_z_specific_delta': procurement.size_z_specific_delta,
                    'diameter_specific_delta': procurement.diameter_specific_delta,
                })
#            else:
#                result[procurement.id] = procurement.production_id.id
            produce_id = result[procurement.id]
            self.write(cr, uid, [procurement.id], {'state':'running', 'production_id':result[procurement.id]})
            childs = [line.id for line in procurement.procurement_line]
            #self.action_produce_assign_product(cr, uid, childs)
            for child in childs:
                wf_service.trg_validate(uid, 'procurement.order',child, 'button_confirm', cr)

#            bom_result = self.pool.get('mrp.production').action_compute(cr, uid,[result[procurement.id]], context)
            
            #================================================
            # Confirmation des productions OU Ajout
            #================================================
            if not procurement.bom_id or not procurement.bom_id.bom_type in ('cut'):
                wf_service.trg_validate(uid, 'mrp.production', result[procurement.id], 'button_confirm', cr)
            else:
                move_obj.write(cr,uid,procurement.move_id.id,{'production_id':result[procurement.id]})
            procurement = self.browse(cr,uid,procurement.id,context)
            print "okokok"
            #===================================================================
            # transfere de la sortie des procurement enfant dans l'entrée de la production
            #===================================================================
            moves = []
            for line in procurement.procurement_line:
                print "line",line,line.production_id
                print "line",line,line.purchase_id
                if line.production_id:
                    moves.extend([i.id for i in line.production_id.move_created_ids])
            for i in moves:
                if i not in [j.id for j in self.pool.get('mrp.production').browse(cr,uid,result[procurement.id]).move_lines]:
                    self.pool.get('mrp.production').write(cr, uid, result[procurement.id], {'move_lines': [(4,i)]})
        return produce_id
    
    _columns = {
            'procurement_id': fields.many2one('procurement.order', 'Procurement Ref', ondelete='cascade', select=True, readonly=True, states={'draft':[('readonly',False)]}),
            'procurement_line': fields.one2many('procurement.order', 'procurement_id', 'Procurement Lines', readonly=True, states={'draft': [('readonly', False)]}),
            'group_property_ids': fields.many2many('mrp.property.group.option', 'mrp_procurement_group_property_rel','procurement_id', 'group_id', 'Product Property Group Rel '),
            'parent_option_id': fields.many2one('product.links', 'Parent Option'),
            'option_ids': fields.many2many('product.links', 'mrp_procurement_options_rel','procurement_id', 'links_id', 'Option'),
            'specific_production':fields.boolean('Specific Production'),
            'note_production':fields.text('Production Note'),
            'size_x': fields.function(_size, multi="size", method=True, string='Width', digits=(16, 5), type='float'),
            'size_y': fields.function(_size, multi="size", method=True, string='Length', digits=(16, 5), type='float'),
            'size_z': fields.function(_size, multi="size", method=True, string='Thickness', digits=(16, 5), type='float'),
            'diameter': fields.function(_size, multi="size", method=True, string='Diameter', digits=(16, 5), type='float'),
            'size_x_specific': fields.float('Width specific', digits=(16, 5), readonly=True ),
            'size_y_specific': fields.float('Length specific', digits=(16, 5), readonly=True),
            'size_z_specific': fields.float('Thickness specific', digits=(16, 5), readonly=True),
            'diameter_specific': fields.float('Diameter specific', digits=(16, 5), readonly=True),
            'size_x_specific_delta': fields.float('Width specific delta', digits=(16, 5), readonly=True),
            'size_y_specific_delta': fields.float('Length specific delta', digits=(16, 5), readonly=True),
            'size_z_specific_delta': fields.float('Thickness specific delta', digits=(16, 5), readonly=True),
            'diameter_specific_delta': fields.float('Diameter specific delta', digits=(16, 5), readonly=True),
            'production_id': fields.many2one('mrp.production', 'Production', select=True),
        }
    _defaults = {
    }
    _order = 'id desc'

    def check_wkf(self, cr, uid, ids, context={}):
        wf_service = netsvc.LocalService("workflow")
        for i in ids :
            wf_service.trg_write(uid, 'procurement.order', i, cr)
        return True
    
procurement_order()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: