# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2007-2014 ASPerience SARL (<http://www.asperience.fr>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
#import openerp.netsvc
from openerp.osv import fields, osv
#from openerp.tools import ustr 
#from openerp.tools.translate import _
#import datetime
#from sets import *

def name_serial(x, y, z, p, f, d):

     lote = '_'
     if (f == 'quadrangular'):
         lote = (str(x) + 'x' + str(y) + 'x' + str(z) + '_' + str(p))
     elif (f == 'cylindrical'):
         lote = (str(d) + 'x' + str(z) + '_' + str(p))

     return lote

def compute_w(cr, uid, factor1, factor2, factor3, factor4, size_x, size_y, size_z, shape, density, diameter):
       resu = {}
       
       size_x = size_x or 0
       size_y = size_y or 0 
       size_z = size_z or 0 
       density = density or 1
       diameter = diameter or 0 
       
       weight = 0
       if shape == 'quadrangular':
           weight = ((size_x * size_y * size_z) * density * factor2 * (math.pow(factor3, 3))) / (factor1 * (math.pow(factor4, 3))) 
           diameter = 0
           volume = size_x * size_y * size_z
       elif shape == 'cylindrical':
               radius = diameter / 2.0
               weight = ((math.pow(radius, 2) * math.pi * size_z) * density * factor2 * (math.pow(factor3, 3))) / (factor1 * (math.pow(factor4, 3)))
               volume = math.pow(radius, 2) * math.pi * size_z
               size_x = 0
               size_y = 0
       else:
               weight = 0
               volume = 0
               size_x = 0
               size_y = 0               
               size_z = 0

               
       v = { 'weight':weight,
             'volume':volume,
             'size_x':size_x,
             'size_y':size_y,
             'size_z':size_z,
             'diameter':diameter,
             'density':density,
             }
       return v  

class product_template(osv.osv):
    _inherit ='product.template'    
    _columns = {
        'size_x_tmpl': fields.float('Width', digits=(16, 5)),
        'size_y_tmpl': fields.float('Length', digits=(16, 5)),
        'size_z_tmpl': fields.float('Thickness', digits=(16, 5)),
        'density_tmpl': fields.float('Density', digits=(16, 5), help='Density unit= (uom of weight/(uom of size)^3)'),
        'shape' : fields.selection([('quadrangular', 'Quadrangular'), ('cylindrical', 'Cylindrical'), ('other', 'Other')], 'Shape', help="Weight Formula for Quadrangular = width*length*thickness*density \n Weight Formula for Cylindrical= (diameter/2)²*pi*thickness*density", required=True),
        'diameter_tmpl': fields.float('Diameter', digits=(16, 5)),
        'uom_d_size' : fields.many2one('product.uom', 'Size density Uom ³', help="Default united of measure density used for operations size to cube", required=True, readonly=True),
        'uom_d_weight': fields.many2one('product.uom', 'Weight density Uom', help="Default united of measure density used for operations weight", required=True, readonly=True),
        'uom_s_size' : fields.many2one('product.uom', 'Size Uom', help="Default united of measure used for operations size", required=True, readonly=True),
    }
    def _get_uom_d_size(self, cr, uid, *args):
        return self.pool.get('ir.property').get(cr, uid, 'uom_d_size', 'product.template')
    
    def _get_uom_d_weight(self, cr, uid, *args):
        return self.pool.get('ir.property').get(cr, uid, 'uom_d_weight', 'product.template')
    
    def _get_uom_s_size(self, cr, uid, *args):
        return self.pool.get('ir.property').get(cr, uid, 'uom_s_size', 'product.template')

    def compute_weight(self, cr, uid, id, uom_d_weight, uom_id, uom_d_size, uom_s_size, size_x, size_y, size_z, shape, density, diameter, size_x_tmpl, size_y_tmpl, size_z_tmpl, density_tmpl, diameter_tmpl):
        value = {}

        if (not uom_id) or (not uom_d_weight) or(not uom_d_size) or (not uom_s_size):
            return 0
        if (shape):
           factor1 = self.pool.get('product.uom').browse(cr, uid, uom_d_weight, context='').factor
           factor2 = self.pool.get('product.uom').browse(cr, uid, uom_id, context='').factor
           factor3 = self.pool.get('product.uom').browse(cr, uid, uom_d_size, context='').factor
           factor4 = self.pool.get('product.uom').browse(cr, uid, uom_s_size, context='').factor
           return {'value': compute_w(cr, uid, factor1, factor2, factor3, factor4, size_x or size_x_tmpl, size_y or size_y_tmpl, size_z or size_z_tmpl, shape, density, diameter or diameter_tmpl)}

    _defaults = {
        'size_x_tmpl': lambda * a: 0.0,
        'size_y_tmpl': lambda * a: 0.0,
        'size_z_tmpl': lambda * a: 0.0,
        'density_tmpl': lambda * a: 0.0,
        'shape': lambda * a: 'other',
        'diameter_tmpl': lambda * a: 0.0,
        'uom_d_size': _get_uom_d_size,
        'uom_d_weight' : _get_uom_d_weight,
        'uom_s_size' : _get_uom_s_size,
        }
product_template()

class product_product(osv.osv):
    _inherit ='product.product'

    def generate_bom(self,cr,uid,ids,context={}):
        print "generate_bom",ids,context
        pre = "generate_bom "
        result = {}
        if "product_qty" not in context :
            context["product_qty"]=1
        if "options" not in context :
            context["options"]=[]
        if "rec" not in context :
            context["rec"]=0
        if "bom_parent" not in context :
            context["bom_parent"]=[]
        product_qty = context["product_qty"]
        
        for product in self.browse(cr,uid,ids,context):
            print pre+"product ",product.name
            result[product.id] = False
            option_name = ""
            bom_components_parent = []
            bom_components = []
            
            if product.bom_ids and context["options"]:
                self.generate_bom(cr,uid,[product.id])
                context["bom_parent"] = self.pool.get('mrp.bom')._bom_find(cr, uid, product.id, product.uom_id.id, [], [])
                bom_components_parent = [(0, 0, {'qty':product_qty, 'bom_id':context["bom_parent"]})]
            if context["options"]:
                option_name = "."
                option_name += ".".join([i.shortcut for i in self.pool.get('product.type.property.option').browse(cr,uid,context["options"])])
                property_ids = [],
                # A MODIFIER
                self.pool.get('product.type.property.option').write(cr,uid,context["options"],{'execution_filter':True})
                # /A MODIFIER
                type_group_ids = [(6, 1, context["options"])]
                if not context["bom_parent"]:
                    raise
                else:
                    # Probable bug
#                    bom_components = [(0, 0, {'bom_id':context["bom_parent"]})]
                    bom_components_parent = [(0, 0, {'qty':context["product_qty"], 'bom_id':context["bom_parent"]})]
                type = 'phantom'
            else:
               property_ids = [(6, 1, [i.id for i in product.bom_property_ids])],
               type_group_ids = [(6, 1, [i.id for i in product.bom_type_group_ids])],
               type = 'normal'
            vals ={             
               'name': product.code+" ["+option_name+"("+"-".join([i.code for i in product.bom_property_ids])+")]",
               'code': product.code,
               'active': True,
               'type': 'normal',
               'date_start': datetime.datetime.now(),
               'product_id': product.id,
               'product_uos_qty': product_qty,
               'product_uos': product.uos_id.id,
               'product_qty': product_qty,
               'product_uom': product.uom_id.id,
               'product_rounding': 1,
               'product_efficiency': 1,
               'shape': product.shape,
               'property_ids': property_ids,
               'type_group_ids': type_group_ids,
               'size_x': product.size_x,
               'size_y': product.size_y,
               'size_z': product.size_z,
               'density': product.density,
               'shape' : product.shape,
               'diameter' : product.diameter,
               'weight': product.weight,
               'bom_components': bom_components,
               'bom_components_parent' :bom_components_parent,
               'type': type,
            }
            result[product.id] = self.pool.get('mrp.bom').create(cr,uid,vals)
        ########################################################################################################################################
           #INTEGRATION DES LIGNES EN bundle_base
            bom_components = []
            print pre+"bom_components avant",bom_components
            if not context["bom_parent"]:
               for i in product.linked_product_ids:
                   if not i.used :
                       continue
                   elif i.link_type in ('bundle_base') :
                       if i.product_id.id == product.id :
                           s = result[product.id]
                       else:
                           s = self.generate_bom(cr,uid,[i.product_id.id],{"rec":context['rec']+1,"product_qty":i.product_qty,"options":[]})[i.product_id.id]
                   else:
                       continue
                   if s not in bom_components:
                       bom_components.append(s)
               for i in product.linked_product_tmpl_ids:
                   if not i.used :
                       continue
                   elif i.link_type in ('bundle_base') :
                       if i.product_id.id == product.id :
                           s = result[product.id]
                       else:
                           s = self.generate_bom(cr,uid,[i.product_id.id],{"rec":context['rec']+1,"product_qty":i.product_qty,"options":[]})[i.product_id.id]
                   else:
                       continue
                   if s not in bom_components:
                       bom_components.append(s)
            print pre+"bom_components apres bundle",bom_components
        ########################################################################################################################################
        ########################################################################################################################################
           #CREATION DES BOM OPTION
            if not context["bom_parent"]:
                nb = 0
                for i in product.linked_product_ids:
#                    if nb == 10 : break
                    nb+=1
                    s = None
                    if not i.used :
                        continue
                    if i.product_id.id == product.id :
                        if context["options"] and i.type_group.id in context["options"] :
                            s = result[product.id]
                    if not s and i.link_type in ('option') :
                        s = self.pool.get('mrp.bom')._bom_find(cr, uid, i.product_id.id, i.product_id.uom_id.id, [], i.type_group and [i.type_group.id] or [])
                    else:
                        continue
                    if s not in bom_components:
                        bom_components.append(s)
                nb = 0
                for i in product.linked_product_tmpl_ids:
#                    if nb == 10 : break
                    nb+=1
                    s = None
                    if not i.used :
                        continue
                    if i.product_id.id == product.id :
                        if context["options"] and i.type_group.id in context["options"] :
                            s = result[product.id]
                    if not s and i.link_type in ('option') :
                        s = self.pool.get('mrp.bom')._bom_find(cr, uid, i.product_id.id, i.product_id.uom_id.id, [], i.type_group and [i.type_group.id] or [])
                    else:
                        continue
                    if s not in bom_components:
                        bom_components.append(s)
            #            else:
            #                bom_lines_multi.append(context["bom_parent"])
            print pre+"bom_components apres options",bom_components   
            if bom_components:
                for i in bom_components:
                    vals = {
                        "bom_id":result[product.id],
                        "component_id":i,
                        "qty":product_qty,
                    }
                    self.pool.get('mrp.bom.component.rel').create(cr,uid,vals)
#                self.pool.get('mrp.bom').write(cr,uid,result[product.id],{'bom_components':[(6,1,bom_components)]})
        ########################################################################################################################################            
           
        #            
        #            match_criterias_field = ['product_id','product_uos_qty','product_uos','product_qty','product_uom','product_rounding','product_efficiency','shape','size_x','size_y','size_z','density','shape','diameter','weight']
        #            match_criterias = [(a,'=',vals[a]) for a in match_criterias_field]
        #            match_ids = self.pool.get('mrp.bom').search(cr,uid,match_criterias)
        #            for match_bom in self.pool.get('mrp.bom').browse(cr,uid,match_ids):
        #                if not Set([i.id for i in match_bom.property_ids]) == Set(vals['property_ids'][0][2]) :
        #                    match_ids.remove(match_bom.id)
        #                    continue
        #                if not Set([i.id for i in match_bom.type_group_ids]) == Set(vals['type_group_ids'][0][2]) :
        #                    match_ids.remove(match_bom.id)
        #                    continue
        #            if match_ids :
        #                result[product.id] = match_ids[0] 
        #            elif context["options"] :
        #                result[product.id] = self.pool.get('mrp.bom').create(cr,uid,vals)
        #            else:
        #                result[product.id] = self.pool.get('mrp.bom').create(cr,uid,vals)
        #                bom_option_ids = []
        #                for i in product.linked_product_ids:
        #                    if not i.used :
        #                        continue
        #    #                    if i.product_id.id == product.id :
        #    #                        continue
        #                    if i.link_type in ('option') :
        #                        s = self.generate_bom(cr,uid,[i.product_id.id],{"rec":context['rec']+1,"product_qty":i.product_qty,"options":i.type_group and [i.type_group.id] or []})[i.product_id.id]
        #                    elif i.link_type in ('bundle_base') :
        #                        s = self.generate_bom(cr,uid,[i.product_id.id],{"rec":context['rec']+1,"product_qty":i.product_qty,"options":[]})[i.product_id.id]
        #                    else:
        #                        continue
        #                    if s not in bom_option_ids:
        #                        bom_option_ids.append(s)
        #                for i in product.linked_product_tmpl_ids:
        #                    if not i.used :
        #                        continue
        #    #                    if i.product_id.id == product.id :
        #    #                        continue
        #                    if i.link_type in ('option') :
        #                        s = self.generate_bom(cr,uid,[i.product_id.id],{"rec":context['rec']+1,"product_qty":i.product_qty,"options":i.type_group and [i.type_group.id] or []})[i.product_id.id]
        #                    elif i.link_type in ('bundle_base') :
        #                        s = self.generate_bom(cr,uid,[i.product_id.id],{"rec":context['rec']+1,"product_qty":i.product_qty,"options":[]})[i.product_id.id]
        #                    else:
        #                        continue
        #                    if s not in bom_option_ids:
        #                        bom_option_ids.append(s)
        #                if bom_option_ids:
        #                    vals ={               
        #                        'bom_components': [(6, 1, bom_option_ids)],
        #                    }
        #                    self.pool.get('mrp.bom').write(cr,uid,result[product.id],vals)
        #                
        #            vals = {
        #            'bom' : True,
        #            }
        #            self.write(cr,uid,ids,vals)
        if context['rec']==0 :
            return True
        cr.commit()
        return result
     
    _columns = {
        #Dimensions
        'size_x': fields.float('Width'),
        'size_y': fields.float('Length'),
        'size_z': fields.float('Thickness'),
        'density': fields.float('Density', help='Density unit= (uom of weight/(uom of size)^3)'),
        'diameter' : fields.float('Diameter'),
        #Production
        'bom': fields.boolean('BoM Generated'),
        'opp': fields.boolean('Rupture assembly'),
        'bom_ids': fields.one2many('mrp.bom', 'product_id', 'BoM'),
        'bom_sub_ids': fields.one2many('mrp.subproduct', 'product_id', 'Sub products'),
        'bom_type_group_ids': fields.many2many('product.type.property.option', 'product_product_group_option_rel', 'product_id','group_id', 'Bom (GOP or GOO)'),
        'bom_property_ids': fields.many2many('mrp.property', 'product_product_property_rel', 'product_id','property_id', 'Bom Properties'),
    }
    _defaults = {
         'bom': lambda *a: False,  
        'size_x': lambda * a: 0.0,
        'size_y': lambda * a: 0.0,
        'size_z': lambda * a: 0.0,
        'density': lambda * a: 0.0,
        'diameter': lambda * a: 0.0,
    }

    def compute_weight(self, cr, uid, id, uom_d_weight, uom_id, uom_d_size, uom_s_size, size_x, size_y, size_z, shape, density, diameter, size_x_tmpl, size_y_tmpl, size_z_tmpl, density_tmpl, diameter_tmpl):
        value = {}

        if (not uom_id) or (not uom_d_weight) or(not uom_d_size) or (not uom_s_size):
            return 0
        if (shape):
           factor1 = self.pool.get('product.uom').browse(cr, uid, uom_d_weight, context='').factor
           factor2 = self.pool.get('product.uom').browse(cr, uid, uom_id, context='').factor
           factor3 = self.pool.get('product.uom').browse(cr, uid, uom_d_size, context='').factor
           factor4 = self.pool.get('product.uom').browse(cr, uid, uom_s_size, context='').factor
           return {'value': compute_w(cr, uid, factor1, factor2, factor3, factor4, size_x or size_x_tmpl, size_y or size_y_tmpl, size_z or size_z_tmpl, shape, density, diameter or diameter_tmpl)}

product_product()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: