# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 ASPerience SARL (<http://www.asperience.fr>). All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import osv
from openerp.tools.translate import _
import openerp.netsvc
import openerp.report
import openerp.tools
import shutil
import os
import time
import math
import logging
_logger = logging.get_logger(__name__)

class report_graph_instance(object):
    def __init__(self, cr, uid, ids, data):
        _logger = netsvc._logger()
        try:
            import pydot
        except Exception,e:
            _logger.notifyChannel('workflow', netsvc.LOG_WARNING,
                    'Import Error for pydot, you will not be able to render workflows\n'
                    'Consider Installing PyDot or dependencies: http://dkbza.org/pydot.html')
            raise e
        self.done = False

#        graph = pydot.Dot(fontsize='16', label="""\\\n\\nBOM: """,
#                          size='10.7, 7.3', center='1', ratio='auto', rotate='90', rankdir='LR'
#                         )
#        graph_instance_get(cr, graph, inst_id, data.get('nested', False))
        graph = pooler.get_pool(cr.dbname).get("mrp.bom").gen_graph_dot(cr,uid,ids)
        
        ps_string = graph.create(prog='dot', format='ps')
        prog = 'ps2pdf'
        args = (prog, '-', '-')
        input, output = tools.exec_command_pipe(*args)
        input.write(ps_string)
        input.close()
        self.result = output.read()
        output.close()
        self.done = True

    def is_done(self):
        return self.done

    def get(self):
        if self.done:
            return self.result
        else:
            return None
        
class bom(report.interface.report_int):
    def __init__(self, name, table):
        report.interface.report_int.__init__(self, name)
        self.table = table

    def result(self):
        if self.obj.is_done():
            return (True, self.obj.get(), 'pdf')
        else:
            return (False, False, False)

    def create(self, cr, uid, ids, data, context={}):
        self.obj = report_graph_instance(cr, uid, ids, data)
        return (self.obj.get(), 'pdf')
    
        
bom('report.bom','product.product')

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: