# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 ASPerience SARL (<http://www.asperience.fr>). All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
class bom_structure(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(bom_structure, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'get_children':self.get_children,
        })

    def get_children(self, object, level=0, object2=False):
        result = []
        def _get_rec(object,level,rec):
            if rec > 20:
                return result
            for l in object:
                res = {}
                res['name'] = l.name
                res['pname'] = l.product_id.name
                res['pqty'] = l.product_qty
                res['uname'] = l.product_uom.name
                res['code'] = l.code
                res['level'] = level
                result.append(res)
                if l.bom_components:
                    if level<6:
                        level += 1
                    if not [i.bom_id for i in l.bom_components]==object:
                        _get_rec([i.bom_id for i in l.bom_components],level,rec+1)
                    if level>0 and level<6:
                        level -= 1
            return result
        
        children = _get_rec(object,level,0)
        
        return children

report_sxw.report_sxw('report.bom.structure','mrp.bom','asperience_mrp/report/bom_structure.rml',parser=bom_structure)


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: