# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2007-TODAY ASPerience SARL (<http://www.asperience.fr>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import fields, osv
import datetime

class product_template(osv.osv):
    _inherit ='product.template'
    
    def _date_touch(self, cursor, user, ids, name, arg, context=None):
        res = {}
        for template in self.browse(cursor, user, ids, context=context):
            fmt = '%Y-%m-%d %H:%M:%S'
            if template.write_date:
                res[template.id] = template.write_date
            else:
                if template.create_date:
                    res[template.id] = template.create_date
                else:
                    res[template.id] = datetime.datetime.now().strftime(fmt)
        return res

    _columns = {
        'create_date': fields.datetime('Date create', readonly=True, help="Date on which template is created."),
        'write_date': fields.datetime('Date write', readonly=True, help="Date on which template is modified."),
        'touch_date': fields.function(_date_touch, readonly=True, method=True, store=True, string='Last modification date', type='date'),
        'touch_datetime': fields.function(_date_touch, readonly=True, method=True, store=True, string='Last modification datetime', type='datetime'),
    }

product_template()

class product_product(osv.osv):
    _inherit ='product.product'
    
    def _date_touch(self, cursor, user, ids, name, arg, context=None):
        res = {}
        for product in self.browse(cursor, user, ids, context=context):
            fmt = '%Y-%m-%d %H:%M:%S'
            if product.write_date:
                res[product.id] = product.write_date
            else:
                if product.create_date:
                    res[product.id] = product.create_date
                else:
                    res[product.id] = datetime.datetime.now().strftime(fmt)
        return res

    _columns = {
        'create_date': fields.datetime('Date create', readonly=True, help="Date on which product is created."),
        'write_date': fields.datetime('Date write', readonly=True, help="Date on which product is modified."),
        'touch_date': fields.function(_date_touch, readonly=True, method=True, store=True, string='Last modification date', type='date'),
        'touch_datetime': fields.function(_date_touch, readonly=True, method=True, store=True, string='Last modification datetime', type='datetime'),
    }

product_product()

class product_supplierinfo(osv.osv):
    _inherit ='product.supplierinfo'
    
    def _date_touch(self, cursor, user, ids, name, arg, context=None):
        res = {}
        for supplierinfo in self.browse(cursor, user, ids, context=context):
            fmt = '%Y-%m-%d %H:%M:%S'
            if supplierinfo.write_date:
                res[supplierinfo.id] = supplierinfo.write_date
            else:
                if supplierinfo.create_date:
                    res[supplierinfo.id] = supplierinfo.create_date
                else:
                    res[supplierinfo.id] = datetime.datetime.now().strftime(fmt)
        return res

    _columns = {
        'create_date': fields.datetime('Date create', readonly=True, help="Date on which product is created."),
        'write_date': fields.datetime('Date write', readonly=True, help="Date on which product is modified."),
        'touch_date': fields.function(_date_touch, readonly=True, method=True, store=True, string='Last modification date', type='date'),
        'touch_datetime': fields.function(_date_touch, readonly=True, method=True, store=True, string='Last modification datetime', type='datetime'),
    }

product_supplierinfo()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: