# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2007-TODAY ASPerience SARL (<http://www.asperience.fr>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import openerp.netsvc
from openerp.osv import fields, osv
import datetime

class sale_order(osv.osv):
    _inherit = "sale.order"
    
    def _date_touch(self, cursor, user, ids, name, arg, context=None):
        res = {}
        for order in self.browse(cursor, user, ids, context=context):
            fmt = '%Y-%m-%d %H:%M:%S'
            if order.write_date:
                res[order.id] = order.write_date
            else:
                if order.create_date:
                    res[order.id] = order.create_date
                else:
                    res[order.id] = datetime.datetime.now().strftime(fmt)
        return res

    _columns = {
        'create_date': fields.datetime('Date create', readonly=True, help="Date on which sales order is created."),
        'write_date': fields.datetime('Date write', readonly=True, help="Date on which sales order is modified."),
        'touch_date': fields.function(_date_touch, readonly=True, method=True, store=True, string='Last modification date', type='date'),
        'touch_datetime': fields.function(_date_touch, readonly=True, method=True, store=True, string='Last modification datetime', type='datetime'),
    }

sale_order()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: