# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2007-TODAY ASPerience SARL (<http://www.asperience.fr>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import pooler
from openerp.osv import fields, osv
from openerp.tools.translate import _
import math

class sale_order(osv.osv):
    _inherit = "sale.order"
    
    #Rate compute change: positive for money in. negative for money out
    def _invoiced_rate(self, cursor, user, ids, name, arg, context=None):
        res = {}
        for sale in self.browse(cursor, user, ids, context=context):
            if sale.invoiced:
                res[sale.id] = 100.0
                continue
            tot = 0.0
            for invoice in sale.invoice_ids:
                if invoice.state not in ('draft', 'cancel'):
                    #ASPerience
                    if invoice.type in ('out_refund','in_refund'):
                        tot -= invoice.amount_untaxed
                    else:
                        tot += invoice.amount_untaxed
                    #Fin ASPerience
            if tot:
                res[sale.id] = tot * 100.0 / (sale.amount_untaxed or 1.00)
            else:
                res[sale.id] = 0.0
        return res

    _columns = {
        'invoiced_rate': fields.function(_invoiced_rate, string='Invoiced', type='float'),
    }
sale_order()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: