# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2007-2014 ASPerience SARL (<http://www.asperience.fr>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from mx import DateTime
import time
import datetime
import openerp.netsvc
from openerp.osv import fields, osv
from openerp.tools import config
from openerp.tools.translate import _
import openerp.tools
from dateutil.relativedelta import relativedelta

class stock_move_attributes(osv.osv):
    _name = 'stock.move.attributes'

    _columns = {
        'stock_move_id': fields.many2one('stock.move', 'id', required=True),
        'code': fields.char('Code', required=True, size=16),
        'value_float': fields.float('Number'),
        'uom_id': fields.many2one('product.uom', 'UoM'),
        'value_txt': fields.char('Text', size=64),
    }
    _order = 'stock_move_id, code'
stock_move_attributes()

class stock_move(osv.osv):
    _inherit = "stock.move"
    
    _columns = {
        'attributes_ids' : fields.one2many('stock.move.attributes', 'stock_move_id', 'Attributes'),
    }
stock_move()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: