
openerp.asperience_flow = function (openerp) {
	

	var QWeb = openerp.web.qweb,
	_t = openerp.web._t,
    _lt = openerp.web._lt;
	openerp.web.views.add('flow', 'openerp.asperience_flow.FlowView');
	
	openerp.asperience_flow.FlowView = openerp.web.View.extend(/** @lends openerp.web.FlowView# */{
	    display_name: _lt('Flow'),
	    /**
	     * Indicates that this view is not searchable, and thus that no search
	     * view should be displayed (if there is one active).
	     */
	    searchable : false,
	    
	    
	    /**
	     * flow view (a dot style graph)
	     *
	     * @constructs openerp.web.FlowView
	     * @extends openerp.web.View
	     *
	     * @param parent
	     * @param dataset
	     * @param view_id
	     * @param options
	     */
	    init: function(parent, dataset, view_id, options) {
	    	/*console.log("parent : ");
	    	console.log(parent);
	    	console.log("dataset : ");
	    	console.log(dataset);
	    	console.log("view_id : ");
	    	console.log(view_id);
	    	console.log("options : ");
	    	console.log(options);*/

	    	//empty view 'flow' for reloading
	    	$("#widget-19_view_flow").html("");
	    	
	        this._super(parent);
	        this.dataset = dataset;
	        this.model = dataset.model;
	        this.view_id = view_id;
	        this.registry = openerp.web.form.widgets;
	        this.records = {};

	        this.options = _.extend({}, this.defaults, options || {});
	        
	    },
	    

	    start: function () {
	        this._super();
	        return this.rpc("/web/view/load", {
	            'model': this.model,
	            'view_id': this.view_id,
	            'view_type': 'flow',
	            toolbar: this.view_manager ? !!this.view_manager.sidebar : false,
	            context: this.dataset.get_context()
	        }, this.on_loaded);
	    },
	    
	    
	    on_loaded: function (fields_view) {
	        var self = this;
	        var has_toolbar = !!fields_view.arch.attrs.toolbar;
	        this.fields_view = fields_view;
	        
	        //Insert canvas in the page
	        this.$element.html(QWeb.render('FlowViewTest'));

	        this.rpc("/web/searchview/fields_get", {
	        	"model": this.dataset.model
	        	}, function(result){
		        		self.dataset.read_slice([],{}).then(function(records) {
			        		
			        		//recovering the number of the record we wish to display
			        		var recordClicked = self.dataset.index || self.gup("id") || 0;
			        		
			        		//Tree creation
			        		var option = {
			        				group : fields_view.model,
			        				linkColor : '#0080FF',
			        				style : 'arrowMiddleInv',
			        				arrowDirection : "true",
			        				edge : 'right',
			        				label : null,
			        				graphExceptionOnly : null,
			        		}
			        		var json = self.algo_rec(result.fields, fields_view.arch, records, recordClicked, option);
			        	
			        		//Graph drawing
			        		self.draw_graph(json, 'infovis');
			        		
			        		//window.location.replace("#id="+recordClicked+"&view_type=flow&model="+fields_view.model+"&action_id=452");
			        		
			        	});
	        });
	        
	        //Events delegation
	        self.event_delegation();
	        
	    },
	    
	    
	    /**
	     * To know parameter's value in URL
	     *
	     * @returns Parameter's value
	     */
	    gup : function ( name ){
	    	name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");  
	    	var regexS = "[\\#&]"+name+"=([^&#]*)";  
	    	var regex = new RegExp( regexS );  
	    	var results = regex.exec( window.location.href ); 
	    	 if( results == null )    return "";  
	    	else    return results[1];
	   },

	   
	    
	    /**
	     * Recursive Tree creation's function from xml structure
	     *
	     * @param fields All fields of the object
	     * @param arch Architecture of the xml
	     * @param records All records of the model
	     * @param click Selected element
	     * @param group Current model
	     * @param linkColor Color of the edge
	     * @param style Style of the edge
	     * @param arrowDirection Direction of the edge
	     * @param edge Edge's orientation
	     * @param label What to show on the edge
	     * @param graphExceptionOnly If a field many2one must be graphed
	     * 
	     * @returns {Array} json, Tree array
	     */
	    algo_rec : function (fields, arch, records, click, option){

	    	var self = this;
	    	
	    	var addLinks = "";
	    	var graphLinks = "";
	    	
	    	//Node's content
	    	var $inside = $(QWeb.render('FlowLabel', {'modl' : option.group}));
	    	
    		var childrenFields = arch.children;
    		var selectedElement = records[click];
    	
    		//ID mustn't include any spaces or symbols
    		var id = selectedElement.id + "_" + selectedElement.name;
    		id = id.split(' ').join('_');
    		id = id.replace(/[^A-Za-z0-9\_]/g,'');
    		
    		var json = {
		            id: id,
		            name: selectedElement.name,
		            data: {
		            	   group : option.group,
		            	   linkColor : option.linkColor,
		            	   edge : option.edge,
		            	   arrowDirection : (option.arrowDirection == "true"),
		            	   style : option.style,
		            	  },
		            children: [],
	        };
    		
    		//Edge's label
    		if(option.label){
				
				json.data.labeltext = QWeb.render('FlowEdgeLabel', {
					'edgeTitle' : fields[option.label].string,
		            'alt': selectedElement.id,
		            'labelContaining' : option.label,
		            'value' : selectedElement[option.label],
		            'currentModel' : option.group,
		        });
			}
    		
    		for (var i in childrenFields)
	        {
    			if (childrenFields[i].attrs.many2oneGraphException && option.graphExceptionOnly && childrenFields[i].attrs.many2oneGraphException != option.graphExceptionOnly) {
    				continue;
				}
    			
    			if (childrenFields[i].tag == "field"){
    				
    				if (fields[childrenFields[i].attrs.name].type != "one2many" && fields[childrenFields[i].attrs.name].type != "many2many"){
    			
    					if(childrenFields[i].attrs.name == "name"){
    						$inside.find(".FlowTitle").append(selectedElement[childrenFields[i].attrs.name]);
    	    			}
    					//If it's a field different from name
    	    			else {
    	    				var interior ="";
    	    				
    	    				if(fields[childrenFields[i].attrs.name].type == "many2one"){
    	    					var elemSelected = selectedElement[childrenFields[i].attrs.name][1];
	    						if(elemSelected.indexOf('[') != -1){
	    							elemSelected = elemSelected.split("] ")[1];
	    			        	}
    	    					interior += QWeb.render('FlowAttributeLink', {
    	    						'title' : fields[childrenFields[i].attrs.name].help,
    	    						'field' : childrenFields[i].attrs.name,
	    				            'name' : fields[childrenFields[i].attrs.name].string,
	    				            'value1' : "#id=" + selectedElement[childrenFields[i].attrs.name][0] + "&view_type=page&model="+ fields[childrenFields[i].attrs.name].relation,
	    				            'value2' : elemSelected,
	    				        });
    	    				}
    	    				//If it's a field many2one
    	    				else {
    	    					interior += QWeb.render('FlowAttribute', {
    	    						'title' : fields[childrenFields[i].attrs.name].help,
    	    						'field' : childrenFields[i].attrs.name,
	    				            'name': fields[childrenFields[i].attrs.name].string,
	    				            'value' : selectedElement[childrenFields[i].attrs.name],
	    				        });
    	    				}
    	    				
    	    				if(childrenFields[i].attrs.hide == 'true'){
    	    					$inside.find(".hiddenDiv").append(interior);
    	    				}
    	    				//If the attribute must be hidden
    	    				else{
    	    					$inside.find(".hiddenDiv").before(interior);
    	    				}
    	    				
    	    			}
    				}
    				//It's a field ...2many
    				else {
    					var kids = [];
    					
    					var one2many = selectedElement[childrenFields[i].attrs.name];
    					
    					for (var j in one2many){
    						
    						var lab = (typeof childrenFields[i].attrs.label !== 'undefined') ? childrenFields[i].attrs.label : null;
    						
    						if(fields[childrenFields[i].attrs.name].relation == this.model){
        						
	    						var i2;
	    						for(i2=0; i2 != records.length && records[i2].id != one2many[j]; i2++);
	    						
	    						if(i2 != records.length){
	    							var opt = {
	    			        				group : this.model,
	    			        				linkColor : childrenFields[i].attrs.color,
	    			        				style : childrenFields[i].attrs.style,
	    			        				arrowDirection : childrenFields[i].attrs.direction,
	    			        				edge : childrenFields[i].attrs.edge,
	    			        				label : lab,
	    			        				graphExceptionOnly : null,
	    			        		}
	    							kids.push( this.algo_rec(fields, arch, records, i2, opt) );
	    						}
    						}
    						//Come from another model
    						else {
    								var callback = function(res){
    									var opt = {
    	    			        				group : res.model,
    	    			        				linkColor : childrenFields[i].attrs.color,
    	    			        				style : childrenFields[i].attrs.style,
    	    			        				arrowDirection : childrenFields[i].attrs.direction,
    	    			        				edge : childrenFields[i].attrs.edge,
    	    			        				label : lab,
    	    			        				graphExceptionOnly : null,
    	    			        		}
    									kids = kids.concat(self.redir(res, selectedElement[childrenFields[i].attrs.name], j, opt));
    								};
    									
    								//on recupere l'architecture xml de la vue
    								this.session.synchronized_mode(function(){
										self.rpc("/web/view/load", {
		    					            'model': fields[childrenFields[i].attrs.name].relation,
		    					            'view_id': false,
		    					            'view_type': 'flow',
		    					            toolbar: self.view_manager ? !!this.view_manager.sidebar : false,
		    					            context: self.dataset.get_context()
		    					        }, callback)
		    					        
    								});
    						}//End of if/else for model
    						
    						//If we should construct a graph from a field many2one
    						if(childrenFields[i].attrs.many2oneGraphException){

    							//Getting dataset
    							var dataset = new openerp.web.DataSetSearch(this.parent, fields[childrenFields[i].attrs.name].relation, this.context, null);
    							
    							this.session.synchronized_mode(function() {
    								//Reading the data
    								dataset.read_slice([], {"domain": [['id','in',one2many]]}).then(function(records4){
        								//Search for the record
    									var ii;
        	    						for(ii=0; ii != records4.length && records4[ii].id != one2many[j]; ii++);
        	    						
        	    						//Getting corresponding ID
        								var theID = records4[ii][childrenFields[i].attrs.many2oneGraphException][0] -1;
        								
        								//Tree construction
        								var opt = {
    	    			        				group : self.model,
    	    			        				linkColor : childrenFields[i].attrs.color,
    	    			        				style : childrenFields[i].attrs.style,
    	    			        				arrowDirection : childrenFields[i].attrs.direction,
    	    			        				edge : childrenFields[i].attrs.edge,
    	    			        				label : null,
    	    			        				graphExceptionOnly : childrenFields[i].attrs.many2oneGraphException,
    	    			        		}
        								var newKid = self.algo_rec(fields, arch, records, theID, opt);
        								
        								//Edge's label saving
        								var theLabel = kids[kids.length-1].data.labeltext;
        								
        								//Placing new node in the tree
        								kids[kids.length-1] = newKid;
        								kids[kids.length-1].data.labeltext = theLabel;
        				        	});
    							});
    							
    						}
    					}//End of for(var j in one2many)
    					
    					
    					var tempAddLinks = "";
    					
    					if(childrenFields[i].attrs.addable == "true"){
    						tempAddLinks += QWeb.render('FlowAddLink', {
    							'style' : "color: "+childrenFields[i].attrs.color+";",
    				            'alt' : selectedElement.id,
    				            'field' : fields[childrenFields[i].attrs.name].relation_field,
    				            'currentModel' : fields[childrenFields[i].attrs.name].relation,
    				            'value' : fields[childrenFields[i].attrs.name].string,
    				        });
    					}
    						
    					
    					if(kids.length){

	    					if(!childrenFields[i].attrs.graph || childrenFields[i].attrs.graph == "outside"){
	    						json.children = json.children.concat(kids);
	    						addLinks += tempAddLinks;
	    		    		}
	    					else {
	    						var newJson = jQuery.extend(true, {}, json);
	        					newJson.id = id +"_" + fields[childrenFields[i].attrs.name].relation;
	        					newJson.children= kids;
	    						
	    						var newInside = $inside.clone();
	    						newInside.find('.listeAtt').html(tempAddLinks);
	    						newInside.find("br:first").remove();
	    						newInside.find('img:last').remove();
	    						newJson.data.relation = newInside.html();
	    						
	    			    		json.data[fields[childrenFields[i].attrs.name].relation] = newJson;
	    						
	    			    		graphLinks += QWeb.render('FlowGraphLink', {
	    							'style' : "color: "+childrenFields[i].attrs.color+";",
	    				            'alt' : id,
	    				            'currentModel' : fields[childrenFields[i].attrs.name].relation,
	    				            'value' : fields[childrenFields[i].attrs.name].string,
	    				        });
	    					}
    					}
    					
    					
    				}//End of if/else for ..2many
	        	}//End of if(childrenFields[i].tag == "field")
	        }//End of for(var i in childrenFields)
    		
    		if(!$inside.find('.FlowTitle').html().trim()){
    			$inside.find('.FlowTitle').css("height","10");
    		}
    		

    		//Adding add links
    		$inside.find(".hiddenDiv").append(addLinks);
    		
    		$inside.find(".hiddenDiv").append(graphLinks);
    		
    		if ($inside.find(".hiddenDiv").html().trim()) {
    			$inside.find(".btn_details").css('visibility', 'visible');
    			$inside.find(".btn_details").attr("alt",json.id);
    		}
    		
    		
    		if($inside.find('li').length){
				$inside.find(".btn_alter").css('display', '');
				$inside.find(".btn_alter").attr("alt",json.id);
    		}
    		
    		
    		json.data.relation = $inside.html();
    		
    		return json;
	    	
	    },
	    
	    
	    redir : function(fields_view, records, ind, opt){
	    	
	    	var self = this;
	    	
	    	var children= [];
	    	
	    	var dataset = new openerp.web.DataSetSearch(this.parent, fields_view.model, this.context, null);
	    	
	    	dataset.read_slice([], {"domain": [['id','in',records]]}).then(function(records2) {
	    		
	    		children.push(self.algo_rec(fields_view.fields, fields_view.arch, records2, ind, opt));
	    		
        	});
	    	
	    	return children;
	    	
	    },
	    
	    
	    /**
	     * Used to create alterable field in nodes
	     *
	     * @param view Field's containing view
	     * @param field Field's name
	     * @param element Field's value
	     * 
	     * @returns {Array} json, Tree array
	     */
	    editable : function(view, field, element){
	    	
	    	var $content = jQuery('<li/>', {
        	    title: view[field].help,
        	    class: 'hideMe alter',
        	    containing: field,
        	    html: view[field].string + ": ",
        	});
	    	
	    	var $subcontent;
   	
	    	
	    	if(view[field].type == 'char' || view[field].type == 'integer' || view[field].type == 'text' || view[field].type == 'float'){

	    		$subcontent = jQuery('<input/>', {
	    			type: 'text',
	    			size: 10,
	    			value: (element != "false")? element : "",
	    			name: field,
	        	});
		    	
	    	}
	    	
	    	else if (view[field].type == 'boolean'){
	    		
	    		$subcontent = jQuery('<select/>', {
	    			name: 'boolean',
	        	});
	    		
	    		$subcontent.append(jQuery('<option/>', {
	    			value: 'true',
	    			html: _t('Yes'),
	        	}));
	    		
	    		$subcontent.append(jQuery('<option/>', {
	    			value: 'false',
	    			html: _t('No'),
	        	}));
	    		
	    		$subcontent.find("[value='"+ element +"']").attr('selected', 'selected');

	    	}
	    	
	    	else if (view[field].type == 'selection'){
	    		
	    		$subcontent = jQuery('<select/>', {
	    			name: 'selection',
	        	});
	    		
	    		for(var ii in view[field].selection){
	    			var $subcontent2 = jQuery('<option/>', {
		    			value: view[field].selection[ii][0],
		    			html: view[field].selection[ii][1],
		        	});
	    			
	    			if(element == view[field].selection[ii][0]){
	    				$subcontent2.attr('selected', 'selected');
	    			}
	    			
	    			$subcontent.append($subcontent2);
	    		}
	    	}
	    	
	    	else if (view[field].type == 'many2one'){
	    		
	        	var model = view[field].relation;
	        	var dataset = new openerp.web.DataSetSearch(this.parent, model);
	        	
	        	this.session.synchronized_mode(function() {
	        		dataset.read_slice([],{offset: 0, limit: 10}).then(function(records2) {
	        			
	        			$subcontent = jQuery('<select/>', {
	    	    			name: 'many2one',
	    	    			model: model,
	    	        	});
	    	    		
	        			$subcontent.append(jQuery('<option/>', {
    		    			value: '',
    		    			html: _t("Please select  (if any change)"),
    		    			selected: 'selected',
    		        	}));
	        			
	    	    		for(var ii in records2){
	    	    			
	    	    			$subcontent.append(jQuery('<option/>', {
	    		    			value: records2[ii].id,
	    		    			html: records2[ii].name,
	    		        	}));
	    		    		
	    	    		}
	    	    		
	    	    		$subcontent.prepend(jQuery('<option/>', {
	    		    			value: '-',
	    		    			number: 0,
	    		    			html: '^',
	    		    			style: "text-align:right",
	    		        	}));
	    	    		$subcontent.append(jQuery('<option/>', {
    		    			value: '+',
    		    			number: 10,
    		    			html: 'v',
    		    			style: "text-align:right",
    		        	}));
	    	    		
	        		});
	        	});
	        	$content.append("<img src='../../../../asperience_flow/static/src/img/glass.png' class='btn_search' model='"+model+"'/>");
	    	}
	    	
	    	else if (view[field].type == 'date'){
	    		$subcontent = jQuery('<input/>', {
	    			name: field,
	    			type: 'text',
	    			class: 'datePicker',
	    			size: '10',
	    			value: element,
	        	});
	    	}
	    	
	    	
	    	$content.append($subcontent);
	    	
	    	var $something = jQuery('<span/>');
	    	$something.append($content);
	    	return $something.html();
	    },
	   
	    
	    /**
	     * Draw the graph
	     *
	     * @param json Object containing the tree to draw
	     * 
	     */
	    draw_graph: function (json, container, edgeSize) {
	    	
	    	var self = this;
    		
	        var Log = {
	          elem: false,
	          write: function(text){
	            if (!this.elem) 
	              this.elem = document.getElementById('log');
	            this.elem.innerHTML = text;
	            this.elem.style.left = (500 - this.elem.offsetWidth / 2) + 'px';
	          }
	        };
	    	
    		//preprocess subtrees orientation
	        var arr = json.children;
	        var len = arr.length;
	        
	        for(var i=0; i < len; i++) {
        	
	          arr[i].data.$orn = arr[i].data.edge;
	          $jit.json.each(arr[i], function(n) {
      			  n.data.$orn = arr[i].data.edge;
      		  });
	        	
	        }
	        //end
	        
	        //init Spacetree
	        //Create a new ST instance
	        var st = new $jit.ST({
	        	
	            //id of viz container element
	            injectInto: container,
	            
	            //multitree
	        	multitree: true,
	        	  
	            //set duration for the animation
	            duration: 800,
	            
	            //set animation transition type
	            transition: $jit.Trans.Quart.easeInOut,
	            
	            //set distance between node and its children
	            levelDistance: (typeof edgeSize !== 'undefined') ? edgeSize : 150,
	            
	            //sibling and subtrees offsets
	            siblingOffset: 25,
	            subtreeOffset: 3,
	            
	            //enable panning
	            Navigation: {
	              enable:true,
	              panning:true
	            },
	            
	            //set node and edge styles

	            Node: {
	            	//info : those height and width won't have any effect at the end
	                height: 25,
	                width: 130,
	                type: 'adv-rect',
	                color: '#aaa',
	                overridable: true,
	                CanvasStyles: {
	                  strokeStyle: "#A40000", // border color
	                  lineWidth: 1.5,
	                  //for rounded corner rectangle
	                  radius: 15
	                }
	            },
	            
	            Edge: {
	                type: 'arrowMiddleInv',
	                overridable: true
	            },
	            
	            onBeforeCompute: function(node){
	                Log.write(_t("Loading of \"") + node.name + "\"");
	            },
	            
	            onAfterCompute: function(){
	                Log.write(_t("Loading done !"));
	                setTimeout(function() {
	                	Log.write(_t("Move graph with mouse</br>Double click on an element to show it"));
	                },1250);
	            },
	            
	            //This method is called on DOM label creation.
	            //Use this method to add event handlers and styles to
	            //your node.
	            onCreateLabel: function(label, node){
	                label.id = node.id;
	                label.innerHTML = node.data.relation;
	                
	                //set label styles
	                var style = label.style; 
	                style.width = node.data.$width + 'px';
	                style.height = node.data.$height + 'px';  
	                //style.cursor = 'pointer';
	                style.color = '#333';
	                style.fontSize = (container == "infovis") ? "12px" : "10px";
	                style.textAlign= 'center';
	                
	                //Label evenements
	                label.onclick = function(event){
	                	
	                	if (!$(event.target).is('.FlowTitle')) {
	                        return;
	                    }
	                	
	                    st.onClick(node.id);
	                };
	                
	                label.ondblclick = function(event){
	                	if (!$(event.target).is('.FlowTitle')) {
	                        return;
	                    }
	                	//Redirect to view 'page' of this object
	                	document.location.href="#id="+label.id.split("_")[0]+"&view_type=page&model="+node.data.group;
	                	return;
	                };
	                
	            },
	            
	            onPlaceLabel: function(label, node){
	            	
	            },
	            
	            //This method is called right before plotting
	            //a node. It's useful for changing an individual node
	            //style properties before plotting it.
	            //The data properties prefixed with a dollar
	            //sign will override the global node style properties.
	            onBeforePlotNode: function(node){
	                //add some color to the nodes in the path between the
	                //root node and the selected node.
	                if (node.selected) {
	                    node.data.$color = "#A40000";
	                }
	                else {
	                    delete node.data.$color;
	                }
	            },
	            
	            //This method is called right before plotting
	            //an edge. It's useful for changing an individual edge
	            //style properties before plotting it.
	            //Edge data proprties prefixed with a dollar sign will
	            //override the Edge global style properties.
	            onBeforePlotLine: function(adj){
	            	
	            	adj.data.$inv = adj.nodeTo.data.arrowDirection;
	            	adj.data.$type = adj.nodeTo.data.style;
	            	
	            	adj.data.labelid = adj.nodeFrom.id + "-" + adj.nodeTo.id;
	            	
	            	adj.data.labeltext = adj.nodeTo.data.labeltext;
	            	
	            	
	                if (adj.nodeFrom.selected && adj.nodeTo.selected) {
	                    adj.data.$color = "#B40431";
	                    adj.data.$lineWidth = 3;
	                }
	                else {
		            	adj.data.$color = adj.nodeTo.data.linkColor;
		            	delete adj.data.$lineWidth;
	                }
	            	
	            }
	        });

	        
	        //Spacetree and json saving
	        if(typeof self.graphs == 'undefined'){
	        	self.graphs = {};
	        }
	        self.graphs[container] = {};
	        self.graphs[container].spaceTree = st;
	        self.graphs[container].json = json;
	        
	        
	        ////////////////nodeDimHelper(json)///////////////////
	        //AUTO RESIZING NODE
	        self['testLabel']= document.createElement('div');
	        self.testLabel.id = "mytestlabel";
	        self.testLabel.style.visibility = "hidden";
	        self.testLabel.style.position = "absolute";
	        self.testLabel.style.color = '#333';
	        self.testLabel.style.backgroundColor = '#A40000';
	        self.testLabel.style.fontSize = (container == "infovis") ? "12px" : "10px";
	        self.testLabel.style.textAlign= 'center';
	        //set fixed width here
	        self.testLabel.style.width = '125px';
	        document.body.appendChild(self.testLabel);
	        
	        var elem = document.getElementById('mytestlabel');
            $jit.json.each(json, function(node) {
              
              elem.innerHTML = node.data.relation;
              node.data.$height = elem.offsetHeight;
              node.data.$width = elem.offsetWidth + 8;
              
            }); 
	        //////////////////////////////////////////////////////
	        
	        $('#mytestlabel').remove();
	        
	        //load json data
	        st.loadJSON(json);
	        //compute node positions and layout
	        st.compute('end');
	        st.select(st.root);
	        //end

	    },
	    
	    /**
	     * Used to auto resize nodes of the graph
	     *
	     * @param container Which graph to affect
	     * @param id The node to resize
	     * @param width Which width to adopt a the begining
	     * 
	     */
	    resize_nodes : function(container, id, width){
	    	var that = this;
	    	var graph = this.graphs[container];
	    	theDiv = $("#"+id);
	    	
	    	document.body.appendChild(that.testLabel); 
	    	
	    	var theNodeContent = theDiv.html();
    		
            var elem = document.getElementById('mytestlabel');
            
            $jit.json.each(graph.json, function(node) {
            	if(node.id == id){
            		elem.style.width = width;
            		elem.style.fontSize = (container == "infovis") ? "12px" : "10px";
            		elem.innerHTML = theNodeContent;
    	            node.data.$height = elem.offsetHeight;
    	            node.data.$width = (elem.offsetWidth > 350)? elem.offsetWidth - elem.offsetWidth*15/100 + 3 : elem.offsetWidth + 3;
    	            node.data.relation = theNodeContent;
    	            
    	            theDiv.animate({
    	                width: node.data.$width,
    	                height: node.data.$height,
    	              }, 500 );
            	}
            
            }); 
            
            graph.spaceTree.op.morph(graph.json, {
                type: 'fade',
                duration: 2000,
                hideLabels: false,
                transition: $jit.Trans.Quart.easeInOut
              });
            
            $('#mytestlabel').remove();
	    },
	    
	    
	    /**
	     * Contains every event delegation for nodes or labels
	     *
	     */
	    event_delegation : function(){
	    	//.delegate() is used because of the jquery version
	    	//it could be replaced with .on() with newer jquery release
	    	
	    	jQuery.expr[':'].regex = function(elem, index, match) {
	    		   var matchParams = match[3].split(','),
	    		       validLabels = /^(data|css):/,
	    		       attr = {
	    		           method: matchParams[0].match(validLabels) ?
	    		                       matchParams[0].split(':')[0] : 'attr',
	    		           property: matchParams.shift().replace(validLabels,'')
	    		       },
	    		       regexFlags = 'ig',
	    		       regex = new RegExp(matchParams.join('').replace(/^\s+|\s+$/g,''), regexFlags);
	    		   return regex.test(jQuery(elem)[attr.method](attr.property));
	    		}
	    	
	    	var that = this;
	    	
	    	////////////////////////////////////////////////////////////////
	    	//A click on a add link : open the "new" popup
	    	////////////////////////////////////////////////////////////////
	    	$("#infovis").delegate(".btn_add", "click", function(event){
	        	var $this = $(this);
	    		
	        	var model = $this.attr("currentModel");
	        	
	        	var id = parseInt($this.attr("alt"));
	        	
	        	var context = that.dataset.get_context();
	        	context['default_' + $this.attr("field")] = id;
	        	
	            var action = {
	            	name: $this.html(),
	                res_model : model,
	                type : 'ir.actions.act_window',
	                context: context,
	                view_type : 'form',
	                view_mode : 'form',
	                views : [[false, 'form']],
	                target : 'new',
	                flags : {
	                    action_buttons : true,
	                    form : {
	                        resize_textareas : true
	                    }
	                }
	            };
	            
	            var action_manager = new openerp.web.ActionManager(that);
	            $.when(action_manager.do_action(action)).then(function() {
	                var controller = action_manager.dialog_viewmanager.views['form'].controller;
	                controller.on_button_cancel.add_last(function(){
	                    action_manager.stop()
	                });
	                controller.do_save.add_last(function(){
	                    action_manager.stop();
	                    
	                    //Empty graph
	                    $("#widget-19_view_flow").find("#infovis").html("");
	                    delete that.graphs;
	                    
	                    //Reloading flow view
	                    that.start();
	                });
	            });
                return false;
            });
	    	
	    	
	    	////////////////////////////////////////////////////////////////
	    	//A click on a details button : expand the node's content
	    	////////////////////////////////////////////////////////////////
	    	$("#infovis").delegate(".btn_details", "click", function(event){
	        	
	    		var $this = $(this);
	    		
	    		$this.closest(".node").find(".graphContainer").detach();
		        
	        	var theNodeHiddenDiv = $("#"+this.alt).find(".hiddenDiv");
	        	
	        	var graphContainer = $this.closest(".graphContainer").attr('id');
	            
	        	theNodeHiddenDiv.toggleClass("hideMe");
	        	that.resize_nodes(graphContainer, this.alt, theNodeHiddenDiv.hasClass("hideMe") ? "125px" : "");
	        	
                return false;
            });
	    	
	    	////////////////////////////////////////////////////////////////
	    	//A click on a graph button : show a graph inside the node
	    	////////////////////////////////////////////////////////////////
	    	$("#infovis").delegate(".btn_graph", "click", function(event){
	        	
	    		var $this = $(this);
	    		
	    		$this.closest(".node").find(".graphContainer").remove();
	        	
	        	var graphContainer = $this.closest(".graphContainer").attr('id');
	        	
	        	var theNodeHiddenDiv = $("#" + $this.attr('alt')).find(".hiddenDiv");
	        	
	        	var myNewJson = $jit.Graph.Util.getNode(that.graphs[graphContainer].spaceTree.graph, $this.attr("alt")).data[$this.attr("currentmodel")];
	        	
	        	var newId = "infovis_"+myNewJson.id;
	        	
	        	var newDiv = jQuery('<div/>', {
	        	    id: newId,
	        	    class: 'graphContainer',
	        	    style: 'margin-left:-15%; height:300px; width:350px;',
	        	});

            	theNodeHiddenDiv.append(newDiv);
				
            	that.resize_nodes(graphContainer, $this.attr("alt"), "");
				
	            that.draw_graph(myNewJson, newId, 50);
	            
                return false;
            });
	        
	    	
	    	////////////////////////////////////////////////////////////////
	    	//A click on the plus/minus button : increase/decrease value of the label
	    	////////////////////////////////////////////////////////////////
	        $("#infovis").delegate(".btn_plus_minus", "click", function(event){
	        	var theInput = $(this).parent().parent().find(".qtyLabel");
	        	
	        	var id = parseInt(theInput.attr("alt"));
	        	
	        	if($(this).hasClass('btn_minus')){
	        		var newQty = parseFloat(theInput.attr("value")) - 0.5;
	        	}
	        	else if($(this).hasClass('btn_plus')){
	        		var newQty = parseFloat(theInput.attr("value")) + 0.5;
	        	}
	        	
	        	theInput.attr("value", newQty);
	        	
                return false;
            });
	        
	        
	    	////////////////////////////////////////////////////////////////
	        //A click on the validate button of the label : validate any change of the qty
	    	////////////////////////////////////////////////////////////////
	        $("#infovis").delegate(".btn_validate_qty", "click", function(event){
	        	
	        	var theInput = $(this).parent().parent().find(".qtyLabel");
	        	
	        	var id = parseInt(theInput.attr("alt"));
	        	
	        	var obj = {};
	        	obj[theInput.attr("labelContaining")] = parseFloat(theInput.attr("value"));
	        	
	        	var currentModel = $(this).attr("currentModel");
	        	var dataset = new openerp.web.DataSet(that, currentModel);
	        	dataset.write(id , obj, {});
	        	
	        	var corresponding = $(this).closest(".label").attr("id").split('-')[1];
	        	$("#" + corresponding).find('li[field="' + theInput.attr('labelContaining') + '"]').find("span").html(parseFloat(theInput.attr("value")));
	        	$("#" + corresponding).find('li[containing="' + theInput.attr('labelContaining') + '"]').find("input").val(parseFloat(theInput.attr("value")));
	        	
                return false;
            });
	        
	        
	    	////////////////////////////////////////////////////////////////
	        //A click on an input text : used to write in textbox that are unreachable with the canvas
	    	////////////////////////////////////////////////////////////////
	        $("#infovis").delegate("input:text", "click", function(event){
	        	var $this = $(this);
	        	$this.select();
	        	if($this.hasClass("datePicker")){
	        		$this.datepicker({ dateFormat: "yy-mm-dd", showButtonPanel: true});
	        		$this.blur();
	        		$this.focus();
	        	}

                return false;
            });
	        
	        
	    	////////////////////////////////////////////////////////////////
	        //A click on the alter button : modification mode of the node
	    	////////////////////////////////////////////////////////////////
	    	$("#infovis").delegate(".btn_alter", "click", function(event){
	        	
	    		var $this = $(this);
	    		
	    		var node = $this.closest(".node");
	    		
	    		node.find(".graphContainer").remove();
	    
	        	var theNodeHiddenDiv = $("#"+this.alt).find(".hiddenDiv");
	        	
	        	var lis = node.find("li");
	        	
	        	var model = $this.attr('modl');
	        	
	        	if(!node.find("li.alter").length){
	        		
		        	that.session.synchronized_mode(function(){
		        		
						that.rpc("/web/view/load", {
				            'model': model,
				            'view_id': false,
				            'view_type': 'flow',
				            toolbar: that.view_manager ? !!that.view_manager.sidebar : false,
				            context: that.dataset.get_context()
				        }, function(res){
				        	
				        	var view = res.fields;
				        	lis.each(function(){
				        		var $$this = $(this);
				        		var element = $$this.find('.element').html();
				        		var field = $$this.attr('field');
				        		
				        		$$this.before(that.editable(view, field, element));
				        	});
				        	
				        })
				        
					});
	        	}
	        	
	        	var lis2 = node.find("li");
	        	
	        	if(theNodeHiddenDiv.hasClass("hideMe")){
	        		theNodeHiddenDiv.toggleClass("hideMe");
	        	}
	        	
	        	node.find(".btn_save").toggle();
	        	
	        	theNodeHiddenDiv.find("a").toggle();
	        	theNodeHiddenDiv.find("br").toggle();
	        	
	        	node.find(".btn_details").toggle();
	        	
	        	lis2.toggleClass("hideMe");
	        	
	        	var graphContainer = $this.closest(".graphContainer").attr('id');
	        	var size = !theNodeHiddenDiv.children().length && !node.find("li:not(.alter)").hasClass("hideMe");
	        	that.resize_nodes(graphContainer, this.alt, size ? "125px" : "");
	        	
                return false;
            });
	    	
	    	
	    	////////////////////////////////////////////////////////////////
	    	//A click on the save button : Save any change of the node's content
	    	////////////////////////////////////////////////////////////////
	    	$("#infovis").delegate(".btn_save", "click", function(event){
	        	
	    		var $this = $(this);
	    		var node = $this.closest(".node");
	    		
	    		var lis = node.find("li.alter");
	    		var lis2 = node.find("li:not(.alter)");
	    		
	    		var id = parseInt(node.attr("id").split("_")[0]);
	    		
	    		var currentModel = (String)($this.attr("modl"));
	    		
	    		var obj = {};
	    		
	    		var exited= false;
	    		lis.each(function(item) {
		        	var $$this = $(this);
		        	var containing = $$this.attr("containing");
		        	var $item = $(lis2[item]);
		        	var $input = $$this.find("input");
		        	
		        	if($input.length){
	        			if($input.hasClass("search")){
	        				alert(_t("Complete research first"));
	        				exited = true;
	        				return false;
	        			}

	        			if($input.hasClass("datePicker") || $input.val() == "" || isNaN($input.val())) {
	        				var val = $input.val();
	        			}
	        			else{
	        				var val = parseFloat($input.val());
	        			}
		        		obj[containing] = val;
		        		$item.find(".element").html(val);
		        		
		        		var edgeLabel = $('div:regex(id,-'+node.attr("id")+'$)').find(".qtyLabel");
		        		if(edgeLabel.attr("labelcontaining") == containing){
		        			edgeLabel.val(val);
		        		}
		        	}
		        	else if($$this.find("select").length){
		        		var $select = $$this.find("select");
		        		
		        		var text = $select.find(":selected").text();
		        		var val = $select.find(":selected").val();
		        		
		        		if($select.attr('name') == 'boolean'){
		        			obj[containing] = (val == "true")? true : false;
		        			$item.find(".element").html(val);
		        		}
		        		else if ($select.attr('name') == 'selection'){
		        			obj[containing] = val;
		        			$item.find(".element").html(val);
		        		}
		        		else if($select.attr('name') == 'many2one'){
		        			if(isNaN(val)){
		        				alert(_t("Select an attribute from the list"));
		        				exited = true;
		        				return false;
		        			}
		        			if(val != ""){
		        				obj[containing] = parseInt(val);
			        			$item.find("a").attr('href',"#id="+ val + "&view_type=page&model=" + $select.attr('model'));
			        			$item.find(".element").html(text);
		        			}
		        		}
		        		
		        	}
		        	
	    		});
	    		if(exited)return;
	    		var dataset = new openerp.web.DataSet(that, currentModel);
	        	dataset.write(id, obj);
	        	
	        	$this.siblings(".btn_alter").click();
	        	
                return false;
            });
	    	
	    	
	    	/////////////////////////////////////////////////////////////
	    	//A click on the search button : show the search field OR execute the research
	    	/////////////////////////////////////////////////////////////
	        $("#infovis").delegate(".btn_search", "click", function(event){
	        	var $this = $(this);
	        	
	        	if(!$this.siblings("input").length){
	        		$this.attr('src', '../../../../asperience_flow/static/src/img/glass2.png');
	        		$this.siblings("select").remove();
	        		$this.after(jQuery('<input/>', {class: 'search', value: "search",}));
	        	}
	        	else{
	        		if($this.siblings("input").val() != "" && $this.siblings("input").val() != "search"){
	        			$this.attr('src', '../../../../asperience_flow/static/src/img/glass.png');
		        		var model = $this.attr('model');
			        	var dataset = new openerp.web.DataSetSearch(that.parent, model);
			    
		        		that.session.synchronized_mode(function() {
			        		dataset.name_search($this.siblings("input").val()).then(function(records2) {
			        			
			        			$this.siblings("input").remove();
			        			
	    	        			var $subcontent = jQuery('<select/>', {
	    	    	    			name: 'many2one',
	    	    	    			model: model,
	    	    	        	});
	    	    	    		
	    	        			$subcontent.append(jQuery('<option/>', {
	        		    			value: '',
	        		    			html: _t("Please select  (if any change)"),
	        		    			selected: 'selected',
	        		        	}));
	    	        			
	    	    	    		for(var ii in records2){
	    	    	    			$subcontent.append(jQuery('<option/>', {
	    	    		    			value: records2[ii][0],
	    	    		    			html: records2[ii][1],
	    	    		        	}));
	    	    		    		
	    	    	    		}
			        			
	    	    	    		$this.after($subcontent);
			        		});
			        	});
	        		}
	        		else{
	        			alert(_t("Enter a search"));
	        		}
	        	}

                return false;
            });
	        
	        
	    	////////////////////////////////////////////////////////////////
	        //A modification of a dropdown  list containing many2one : next or previous options
	    	////////////////////////////////////////////////////////////////
	        $("#infovis").delegate("select[name='many2one']", "change", function(event){
	        	var $this = $(this);
	        	var val = $this.val();
	        	
	        	if(val == '-' || val == '+'){
	        		var number1;
	        		
		        	if($this.val() == '-'){
		        		number1 = parseInt($this.find("option:first").attr('number')) - 10;
		        		if(number1 < 0) number1=0;
		        	}
		        	if($this.val() == '+'){
		        		number1 = parseInt($this.find("option:last").attr('number')) +1;
		        	}
		        	var number2 = number1 + 10;
		        	
		        	var model = $this.attr('model');
		        	var dataset = new openerp.web.DataSetSearch(that.parent, model);
		        	
		        	that.session.synchronized_mode(function() {
		        		dataset.read_slice([],{offset: number1, limit: 10}).then(function(records2) {
		        			
		        			if(records2.length){
			        			
			        			$this.empty();
			        			
			        			$this.append(jQuery('<option/>', {
		    		    			value: '',
		    		    			html: _t("Please select  (if any change)"),
		    		        	}));
			    	    		
			    	    		for(var ii in records2){
			    	    			var $subcontent2 = jQuery('<option/>', {
			    		    			value: records2[ii].id,
			    		    			html: records2[ii].name,
			    		        	});
			    	    			
			    	    			$this.append($subcontent2);
			    	    		}
			    	    		
			    	    		$this.prepend(jQuery('<option/>', {
			    		    			value: '-',
			    		    			number: number1,
			    		    			html: '^',
			    		    			style: "text-align:right",
			    		        	}));
			    	    		$this.append(jQuery('<option/>', {
		    		    			value: '+',
		    		    			number: number2,
		    		    			html: 'v',
		    		    			style: "text-align:right",
		    		        	}));
		        			}
		        			$this.find("option[value='']").attr('selected','selected);')
		        		});
		        	});
	        	}
                return false;
            });
	       
	        
	    },
	    
	});
	
};

// vim:et fdc=0 fdl=0 foldnestmax=3 fdm=syntax:
